/*----------------------------------------------------------------------------/
/  FatFs - FAŢ ђPʕ  R0.11a                    (C)ChaN, 2015        /
/-----------------------------------------------------------------------------/
/ FatFsPʕ͈ȉ̏̋jŊJ閳̿ĳłB
/
/ 쌠 (C) 2015, ChaN, s
/
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
/
/ ̿ĳ͒쌠ێ҂ƍv҂ɂ"󂻂̂܂"Œ񋟂A̿ĳ
/ Ɋ֘Aǂȕۏ؂Ɛӂ܂B
/ 쌠L҂܂͍v҂͂̿ĳ̎gpɂĔǂȏQɑ΂
/ ӔC𕉂܂B
/----------------------------------------------------------------------------*/

#include "ff.h"			/* FatFs API̐錾 */
#include "diskio.h"		/* ިo͊֐̐錾 */

/*--------------------------------------------------------------------------

   PʕI`

---------------------------------------------------------------------------*/

#if _FATFS != 64180		/* ID */
#error Wrong include file (ff.h).
#endif

/* ē\֌W */
#if _FS_REENTRANT
#if _USE_LFN == 1
#error Static LFN work area cannot be used at thread-safe configuration
#endif
#define	ENTER_FF(fs)		{ if (!lock_fs(fs)) return FR_TIMEOUT; }
#define	LEAVE_FF(fs, res)	{ unlock_fs(fs, res); return res; }
#else
#define	ENTER_FF(fs)
#define LEAVE_FF(fs, res)	return res
#endif

#define	ABORT(fs, res)		{ fp->err = (BYTE)(res); LEAVE_FF(fs, res); }

/* ̑傫̒` */
#if (_MAX_SS < _MIN_SS) || (_MAX_SS != 512 && _MAX_SS != 1024 && _MAX_SS != 2048 && _MAX_SS != 4096) || (_MIN_SS != 512 && _MIN_SS != 1024 && _MIN_SS != 2048 && _MIN_SS != 4096)
#error Wrong sector size configuration
#endif
#if _MAX_SS == _MIN_SS
#define	SS(fs)	((UINT)_MAX_SS)	/* Œ辸e */
#else
#define	SS(fs)	((fs)->ssize)	/* Ͼe */
#endif

/* @\ */
#if _FS_NORTC == 1
#if _NORTC_YEAR < 1980 || _NORTC_YEAR > 2107 || _NORTC_MON < 1 || _NORTC_MON > 12 || _NORTC_MDAY < 1 || _NORTC_MDAY > 31
#error Invalid _FS_NORTC settings
#endif
#define GET_FATTIME()	((DWORD)(_NORTC_YEAR - 1980) << 25 | (DWORD)_NORTC_MON << 21 | (DWORD)_NORTC_MDAY << 16)
#else
#define GET_FATTIME()	get_fattime()
#endif

/* ̧ @\ */
#if _FS_LOCK
#if _FS_READONLY
#error _FS_LOCK must be 0 at read-only configuration
#endif
typedef struct {
	FATFS *fs;		/* ΏەID 1, ح (NULL:󔒓) */
	DWORD clu;		/* ΏەID 2, ިڸ (0:{) */
	WORD idx;		/* ΏەID 3, ިڸ؎wW */
	WORD ctr;		/* ΏەJv, 0:Ȃ, 0x01..0xFF:ǂݍݓJ, 0x100:ݓ */
} FILESEM;
#endif

/* DBCS͈͂SBCS㑤ϊ\ */

#if _CODE_PAGE == 932	/* { Shift-JIS */
#define _DF1S	0x81	/* DBC1޲Ĕ͈1Jn */
#define _DF1E	0x9F	/* DBC1޲Ĕ͈1I */
#define _DF2S	0xE0	/* DBC1޲Ĕ͈2Jn */
#define _DF2E	0xFC	/* DBC1޲Ĕ͈2I */
#define _DS1S	0x40	/* DBC2޲Ĕ͈1Jn */
#define _DS1E	0x7E	/* DBC2޲Ĕ͈1I */
#define _DS2S	0x80	/* DBC2޲Ĕ͈2Jn */
#define _DS2E	0xFC	/* DBC2޲Ĕ͈2I */

#elif _CODE_PAGE == 936	/* ȑ̒ GBK */
#define _DF1S	0x81
#define _DF1E	0xFE
#define _DS1S	0x40
#define _DS1E	0x7E
#define _DS2S	0x80
#define _DS2E	0xFE

#elif _CODE_PAGE == 949	/* N */
#define _DF1S	0x81
#define _DF1E	0xFE
#define _DS1S	0x41
#define _DS1E	0x5A
#define _DS2S	0x61
#define _DS2E	0x7A
#define _DS3S	0x81
#define _DS3E	0xFE

#elif _CODE_PAGE == 950	/* ɑ̒ Big5 */
#define _DF1S	0x81
#define _DF1E	0xFE
#define _DS1S	0x40
#define _DS1E	0x7E
#define _DS2S	0xA1
#define _DS2E	0xFE

#elif _CODE_PAGE == 437	/* Č */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x45,0x41,0x8E,0x41,0x8F,0x80,0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F, \
				0x90,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,0x59,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 720	/* ޱ */
#define _DF1S	0
#define _EXCVT {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 737	/* ؼ */
#define _DF1S	0
#define _EXCVT {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0x90,0x92,0x92,0x93,0x94,0x95,0x96,0x97,0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87, \
				0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,0x91,0xAA,0x92,0x93,0x94,0x95,0x96, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0x97,0xEA,0xEB,0xEC,0xE4,0xED,0xEE,0xEF,0xF5,0xF0,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 771	/* ތ */
#define _DF1S	0
#define _EXCVT {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDC,0xDE,0xDE, \
				0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0xF0,0xF0,0xF2,0xF2,0xF4,0xF4,0xF6,0xF6,0xF8,0xF8,0xFA,0xFA,0xFC,0xFC,0xFE,0xFF}

#elif _CODE_PAGE == 775	/* Č */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x91,0xA0,0x8E,0x95,0x8F,0x80,0xAD,0xED,0x8A,0x8A,0xA1,0x8D,0x8E,0x8F, \
				0x90,0x92,0x92,0xE2,0x99,0x95,0x96,0x97,0x97,0x99,0x9A,0x9D,0x9C,0x9D,0x9E,0x9F, \
				0xA0,0xA1,0xE0,0xA3,0xA3,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xB5,0xB6,0xB7,0xB8,0xBD,0xBE,0xC6,0xC7,0xA5,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE5,0xE5,0xE6,0xE3,0xE8,0xE8,0xEA,0xEA,0xEE,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 850	/* ݌1 */
#define _DF1S	0
#define _EXCVT {0x43,0x55,0x45,0x41,0x41,0x41,0x41,0x43,0x45,0x45,0x45,0x49,0x49,0x49,0x41,0x41, \
				0x45,0x92,0x92,0x4F,0x4F,0x4F,0x55,0x55,0x59,0x4F,0x55,0x4F,0x9C,0x4F,0x9E,0x9F, \
				0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0x41,0x41,0x41,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0x41,0x41,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD1,0xD1,0x45,0x45,0x45,0x49,0x49,0x49,0x49,0xD9,0xDA,0xDB,0xDC,0xDD,0x49,0xDF, \
				0x4F,0xE1,0x4F,0x4F,0x4F,0x4F,0xE6,0xE8,0xE8,0x55,0x55,0x55,0x59,0x59,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 852	/* ݌2 */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x90,0xB6,0x8E,0xDE,0x8F,0x80,0x9D,0xD3,0x8A,0x8A,0xD7,0x8D,0x8E,0x8F, \
				0x90,0x91,0x91,0xE2,0x99,0x95,0x95,0x97,0x97,0x99,0x9A,0x9B,0x9B,0x9D,0x9E,0xAC, \
				0xB5,0xD6,0xE0,0xE9,0xA4,0xA4,0xA6,0xA6,0xA8,0xA8,0xAA,0x8D,0xAC,0xB8,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBD,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC6,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD1,0xD1,0xD2,0xD3,0xD2,0xD5,0xD6,0xD7,0xB7,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE3,0xD5,0xE6,0xE6,0xE8,0xE9,0xE8,0xEB,0xED,0xED,0xDD,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xEB,0xFC,0xFC,0xFE,0xFF}

#elif _CODE_PAGE == 855	/* ٌ */
#define _DF1S	0
#define _EXCVT {0x81,0x81,0x83,0x83,0x85,0x85,0x87,0x87,0x89,0x89,0x8B,0x8B,0x8D,0x8D,0x8F,0x8F, \
				0x91,0x91,0x93,0x93,0x95,0x95,0x97,0x97,0x99,0x99,0x9B,0x9B,0x9D,0x9D,0x9F,0x9F, \
				0xA1,0xA1,0xA3,0xA3,0xA5,0xA5,0xA7,0xA7,0xA9,0xA9,0xAB,0xAB,0xAD,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB6,0xB6,0xB8,0xB8,0xB9,0xBA,0xBB,0xBC,0xBE,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC7,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD1,0xD1,0xD3,0xD3,0xD5,0xD5,0xD7,0xD7,0xDD,0xD9,0xDA,0xDB,0xDC,0xDD,0xE0,0xDF, \
				0xE0,0xE2,0xE2,0xE4,0xE4,0xE6,0xE6,0xE8,0xE8,0xEA,0xEA,0xEC,0xEC,0xEE,0xEE,0xEF, \
				0xF0,0xF2,0xF2,0xF4,0xF4,0xF6,0xF6,0xF8,0xF8,0xFA,0xFA,0xFC,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 857	/* ٺ */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x90,0xB6,0x8E,0xB7,0x8F,0x80,0xD2,0xD3,0xD4,0xD8,0xD7,0x49,0x8E,0x8F, \
				0x90,0x92,0x92,0xE2,0x99,0xE3,0xEA,0xEB,0x98,0x99,0x9A,0x9D,0x9C,0x9D,0x9E,0x9E, \
				0xB5,0xD6,0xE0,0xE9,0xA5,0xA5,0xA6,0xA6,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC7,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0x49,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE5,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xDE,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 860	/* Ķٌ */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x90,0x8F,0x8E,0x91,0x86,0x80,0x89,0x89,0x92,0x8B,0x8C,0x98,0x8E,0x8F, \
				0x90,0x91,0x92,0x8C,0x99,0xA9,0x96,0x9D,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x86,0x8B,0x9F,0x96,0xA5,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 861	/* ތ */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x90,0x41,0x8E,0x41,0x8F,0x80,0x45,0x45,0x45,0x8B,0x8B,0x8D,0x8E,0x8F, \
				0x90,0x92,0x92,0x4F,0x99,0x8D,0x55,0x97,0x97,0x99,0x9A,0x9D,0x9C,0x9D,0x9E,0x9F, \
				0xA4,0xA5,0xA6,0xA7,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 862	/* ײ */
#define _DF1S	0
#define _EXCVT {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 863	/* B */
#define _DF1S	0
#define _EXCVT {0x43,0x55,0x45,0x41,0x41,0x41,0x86,0x43,0x45,0x45,0x45,0x49,0x49,0x8D,0x41,0x8F, \
				0x45,0x45,0x45,0x4F,0x45,0x49,0x55,0x55,0x98,0x4F,0x55,0x9B,0x9C,0x55,0x55,0x9F, \
				0xA0,0xA1,0x4F,0x55,0xA4,0xA5,0xA6,0xA7,0x49,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 864	/* ޱ */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x45,0x41,0x8E,0x41,0x8F,0x80,0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F, \
				0x90,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,0x59,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 865	/* ٳ */
#define _DF1S	0
#define _EXCVT {0x80,0x9A,0x90,0x41,0x8E,0x41,0x8F,0x80,0x45,0x45,0x45,0x49,0x49,0x49,0x8E,0x8F, \
				0x90,0x92,0x92,0x4F,0x99,0x4F,0x55,0x55,0x59,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x41,0x49,0x4F,0x55,0xA5,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF, \
				0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 866	/* ۼ */
#define _DF1S	0
#define _EXCVT {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF, \
				0x90,0x91,0x92,0x93,0x9d,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F, \
				0xF0,0xF0,0xF2,0xF2,0xF4,0xF4,0xF6,0xF6,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF}

#elif _CODE_PAGE == 869	/* ؼ2 */
#define _DF1S	0
#define _EXCVT {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F, \
				0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x86,0x9C,0x8D,0x8F,0x90, \
				0x91,0x90,0x92,0x95,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF, \
				0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF, \
				0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF, \
				0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xA4,0xA5,0xA6,0xD9,0xDA,0xDB,0xDC,0xA7,0xA8,0xDF, \
				0xA9,0xAA,0xAC,0xAD,0xB5,0xB6,0xB7,0xB8,0xBD,0xBE,0xC6,0xC7,0xCF,0xCF,0xD0,0xEF, \
				0xF0,0xF1,0xD1,0xD2,0xD3,0xF5,0xD4,0xF7,0xF8,0xF9,0xD5,0x96,0x95,0x98,0xFE,0xFF}

#elif _CODE_PAGE == 1	/* ASCII (LFN(̧ٖ)`Ԑݒp) */
#if _USE_LFN
#error Cannot use LFN feature without valid code page.
#endif
#define _DF1S	0

#else
#error Unknown code page

#endif

/* xmacros */
#define IsUpper(c)	(((c)>='A')&&((c)<='Z'))
#define IsLower(c)	(((c)>='a')&&((c)<='z'))
#define IsDigit(c)	(((c)>='0')&&((c)<='9'))

#if _DF1S		/*  ߰ނDBCS */

#ifdef _DF2S	/* 2̑1޲ė̈ */
#define IsDBCS1(c)	(((BYTE)(c) >= _DF1S && (BYTE)(c) <= _DF1E) || ((BYTE)(c) >= _DF2S && (BYTE)(c) <= _DF2E))
#else			/* 1̑1޲ė̈ */
#define IsDBCS1(c)	((BYTE)(c) >= _DF1S && (BYTE)(c) <= _DF1E)
#endif

#ifdef _DS3S	/* 3̑2޲ė̈ */
#define IsDBCS2(c)	(((BYTE)(c) >= _DS1S && (BYTE)(c) <= _DS1E) || ((BYTE)(c) >= _DS2S && (BYTE)(c) <= _DS2E) || ((BYTE)(c) >= _DS3S && (BYTE)(c) <= _DS3E))
#else			/* 2̑2޲ė̈ */
#define IsDBCS2(c)	(((BYTE)(c) >= _DS1S && (BYTE)(c) <= _DS1E) || ((BYTE)(c) >= _DS2S && (BYTE)(c) <= _DS2E))
#endif

#else			/*  ߰ނSBCS */

#define IsDBCS1(c)	0
#define IsDBCS2(c)	0

#endif /* _DF1S */

/* O׸ */
#define NSFLAG		11		/* fn[]̖O޲Ă̎wW */
#define NS_LOSS		0x01	/* 8.3`O */
#define NS_LFN		0x02	/* LFN쐬 */
#define NS_LAST		0x04	/* ŏI */
#define NS_BODY		0x08	/* ׸({) */
#define NS_EXT		0x10	/* ׸(gq) */
#define NS_DOT		0x20	/* _ */


/* FAT`E (dlƂ͈Ⴂ܂DOS/Windowsɑ΂Ă͐łB) */
#define MIN_FAT16	4086U	/* FAT16̍ŏ׽ */
#define MIN_FAT32	65526U	/* FAT32̍ŏ׽ */

/* ̍\̂eՊԂ2i݊łȂ߁AFatFs͍\ނ̑޲Ĕz
/ ƂFAT\̓ނQƂ܂B */

#define BS_jmpBoot			0		/* x86򖽗 (3) */
#define BS_OEMName			3		/* OEM (8) */
#define BPB_BytsPerSec		11		/* e[޲] (2) */
#define BPB_SecPerClus		13		/* ׽e[] (1) */
#define BPB_RsvdSecCnt		14		/* \̈e[] (2) */
#define BPB_NumFATs			16		/* FAT (1) */
#define BPB_RootEntCnt		17		/* FAT12/16p{ިڸؓ (2) */
#define BPB_TotSec16		19		/* حїe[] (2) */
#define BPB_Media			21		/* }̋Lqq (1) */
#define BPB_FATSz16			22		/* FATe[] (2) */
#define BPB_SecPerTrk		24		/* ׯe[] (2) */
#define BPB_NumHeads		26		/* ͯސ (2) */
#define BPB_HiddSec			28		/* B (4) */
#define BPB_TotSec32		32		/* حїe[] (4) */
#define BS_DrvNum			36		/* ײޔԍ (1) */
#define BS_NTres			37		/* ُ׸ (1) */
#define BS_BootSig			38		/* gްĎ[ (1) */
#define BS_VolID			39		/* حђʔ (4) */
#define BS_VolLab			43		/* ح  (8) */
#define BS_FilSysType		54		/* ̧ ь` (1) */
#define BPB_FATSz32			36		/* FATe[] (4) */
#define BPB_ExtFlags		40		/* g׸ (2) */
#define BPB_FSVer			42		/* ̧ єŔԍ (2) */
#define BPB_RootClus		44		/* {ިڸؐ擪׽ (4) */
#define BPB_FSInfo			48		/* FSINFO̕ψ (2) */
#define BPB_BkBootSec		50		/* ް ̕ψ (2) */
#define BS_DrvNum32			64		/* ײޔԍ (1) */
#define BS_NTres32			65		/* ُ׸ (1) */
#define BS_BootSig32		66		/* gްĎ[ (1) */
#define BS_VolID32			67		/* حђʔ (4) */
#define BS_VolLab32			71		/* ح  (8) */
#define BS_FilSysType32		82		/* ̧ ь` (1) */
#define	FSI_LeadSig			0		/* FSI: 擱[ (4) */
#define	FSI_StrucSig		484		/* FSI: \̎[ (4) */
#define	FSI_Free_Count		488		/* FSI: 󂫸׽ (4) */
#define	FSI_Nxt_Free		492		/* FSI: ŏI蓖ĸ׽ (4) */
#define MBR_Table			446		/* MBR: ߰èݕ\ψ (2) */
#define	SZ_PTE				16		/* MBR: ߰èݕ\̑傫 */
#define BS_55AA				510		/* [ (2) */

#define	DIR_Name			0		/* Z̧ٖ (11) */
#define	DIR_Attr			11		/*  (1) */
#define	DIR_NTres			12		/* ׸ (1) */
#define DIR_CrtTimeTenth	13		/* 쐬Ԃ1bȉ (1) */
#define	DIR_CrtTime			14		/* 쐬 (2) */
#define	DIR_CrtDate			16		/* 쐬t (2) */
#define DIR_LstAccDate		18		/* ŏIt (2) */
#define	DIR_FstClusHI		20		/* 擪׽̏16ޯ (2) */
#define	DIR_WrtTime			22		/* ύX (2) */
#define	DIR_WrtDate			24		/* ύXt (2) */
#define	DIR_FstClusLO		26		/* 擪׽̉16ޯ (2) */
#define	DIR_FileSize		28		/* ̧ٗe (4) */
#define	LDIR_Ord			0		/* LFN͏LLE׸ (1) */
#define	LDIR_Attr			11		/* LFN (1) */
#define	LDIR_Type			12		/* LFN` (1) */
#define	LDIR_Chksum			13		/* ΉSFN */
#define	LDIR_FstClusLO		26		/* 0łȂ΂Ȃ܂B (0) */
#define	SZ_DIRE				32		/* ިڸؓ̑傫 */
#define	LLEF				0x40	/* LDIR_Ordł̍ŏI׸ */
#define	DDEM				0xE5	/* DIR_Name[0]ł̍폜ިڸؓ */
#define	RDDEM				0x05	/* DDEMł̕Փ˂̒u */


/*--------------------------------------------------------------------------

   PʕIƗ̈

---------------------------------------------------------------------------*/

/* : ÓIԂϐ͎n0/Nullۏ؂܂BȂ
/	   ΁Aݶ܂͎nnٰ݂ANSI-CWł͂܂B
*/

#if _VOLUMES < 1 || _VOLUMES > 9
#error Wrong _VOLUMES setting
#endif
static FATFS *FatFs[_VOLUMES];	/* ̧ ёΏە(_ײ)ւ̈ʒuwq */
static WORD Fsid;				/* ̧ ёID */

#if _FS_RPATH && _VOLUMES >= 2
static BYTE CurrVol;			/* ݂ײ */
#endif

#if _FS_LOCK
static FILESEM Files[_FS_LOCK];	/* Ώە{̫ */
#endif

#if _USE_LFN == 0			/* LFN@\ */
#define	DEFINE_NAMEBUF		BYTE sfn[12]
#define INIT_BUF(dobj)		(dobj).fn = sfn
#define	FREE_BUF()
#else
#if _MAX_LFN < 12 || _MAX_LFN > 255
#error Wrong _MAX_LFN setting
#endif
#if _USE_LFN == 1			/* ÓIƊɏՕLFN@\ */
static WCHAR LfnBuf[_MAX_LFN + 1];
#define	DEFINE_NAMEBUF		BYTE sfn[12]
#define INIT_BUF(dobj)		{ (dobj).fn = sfn; (dobj).lfn = LfnBuf; }
#define	FREE_BUF()
#elif _USE_LFN == 2 		/* ɓIƊɏՕLFN@\ */
#define	DEFINE_NAMEBUF		BYTE sfn[12]; WCHAR lbuf[_MAX_LFN + 1]
#define INIT_BUF(dobj)		{ (dobj).fn = sfn; (dobj).lfn = lbuf; }
#define	FREE_BUF()
#elif _USE_LFN == 3 		/* ˰ߏɓIƊɏՕLFN@\ */
#define	DEFINE_NAMEBUF		BYTE sfn[12]; WCHAR *lfn
#define INIT_BUF(dobj)		{ lfn = ff_memalloc((_MAX_LFN + 1) * 2); if (!lfn) LEAVE_FF((dobj).fs, FR_NOT_ENOUGH_CORE); (dobj).lfn = lfn; (dobj).fn = sfn; }
#define	FREE_BUF()			ff_memfree(lfn)
#else
#error Wrong _USE_LFN setting
#endif
#endif

#ifdef _EXCVT
static const BYTE ExCvt[] = _EXCVT;	/* Upper conversion table for SBCSgp㑤ύX\ */
#endif


/*--------------------------------------------------------------------------

   PʕI֐

---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* ֐
/*-----------------------------------------------------------------------*/

/* ؁ؕ */
static
void mem_cpy (void* dst, const void* src, UINT cnt) {
	BYTE *d = (BYTE*)dst;
	const BYTE *s = (const BYTE*)src;

#if _WORD_ACCESS == 1
	while (cnt >= sizeof (int)) {
		*(int*)d = *(int*)s;
		d += sizeof (int); s += sizeof (int);
		cnt -= sizeof (int);
	}
#endif
	while (cnt--)
		*d++ = *s++;
}

/* ؓhׂ */
static
void mem_set (void* dst, int val, UINT cnt) {
	BYTE *d = (BYTE*)dst;

	while (cnt--)
		*d++ = (BYTE)val;
}

/* ؂؊Ԃ̔r */
static
int mem_cmp (const void* dst, const void* src, UINT cnt) {
	const BYTE *d = (const BYTE *)dst, *s = (const BYTE *)src;
	int r = 0;

	while (cnt-- && (r = *d++ - *s++) == 0) ;
	return r;
}

/* chr܂ނ */
static
int chk_chr (const char* str, int chr) {
	while (*str && *str != chr) str++;
	return *str;
}

/*-----------------------------------------------------------------------*/
/* حт𱸾邽߂̗̏v/                                 */
/*-----------------------------------------------------------------------*/
#if _FS_REENTRANT
static
int lock_fs (
	FATFS* fs		/* ̧ ёΏە */
)
{
	return ff_req_grant(fs->sobj);
}

static
void unlock_fs (
	FATFS* fs,		/* ̧ ёΏە */
	FRESULT res		/* Ԃׂʕ */
)
{
	if (fs &&
		res != FR_NOT_ENABLED &&
		res != FR_INVALID_DRIVE &&
		res != FR_INVALID_OBJECT &&
		res != FR_TIMEOUT) {
		ff_rel_grant(fs->sobj);
	}
}
#endif

/*-----------------------------------------------------------------------*/
/* َ̧{֐                                                      */
/*-----------------------------------------------------------------------*/
#if _FS_LOCK

static
FRESULT chk_lock (	/* ̧قł邩𒲍 */
	DIR* dp,		/* ׂ̧قިڸؑΏە */
	int acc			/* ]ޱ` (0:ǂ݁A1:A2:폜/) */
)
{
	UINT i, be;

	/* ̧ ̫\ */
	for (i = be = 0; i < _FS_LOCK; i++) {
		if (Files[i].fs) {	/*  */
			if (Files[i].fs == dp->fs &&	 	/* ΏەƈvΏە */
				Files[i].clu == dp->sclust &&
				Files[i].idx == dp->index) break;
		} else {			/* 󔒓 */
			be = 1;
		}
	}
	if (i == _FS_LOCK)	/* Ώە */
		return (be || acc == 2) ? FR_OK : FR_TOO_MANY_OPEN_FILES;	/* VKΏەpɋ󔒓L邩? */

	/* ΏەBُ̧݂ƑSĂ̏ݓɋtĂǂȉ */
	return (acc || Files[i].ctr == 0x100) ? FR_LOCKED : FR_OK;
}

static
int enq_lock (void)	/* VKΏەpɗp\ */
{
	UINT i;

	for (i = 0; i < _FS_LOCK && Files[i].fs; i++) ;
	return (i == _FS_LOCK) ? 0 : 1;
}


static
UINT inc_lock (	/* ΏەvisA̎wWԂB (0:ُ) */
	DIR* dp,	/* o^܂͐is邽߂̧قިڸؑΏە */
	int acc		/* ]ޱ (0:ǂށA1:A2:폜/) */
)
{
	UINT i;

	for (i = 0; i < _FS_LOCK; i++) {	/* Ώە */
		if (Files[i].fs == dp->fs &&
			Files[i].clu == dp->sclust &&
			Files[i].idx == dp->index) break;
	}

	if (i == _FS_LOCK) {				/* AVKƂēo^ */
		for (i = 0; i < _FS_LOCK && Files[i].fs; i++) ;
		if (i == _FS_LOCK) return 0;	/* o^̂߂̋󂫓Ȃ(ُ) */
		Files[i].fs = dp->fs;
		Files[i].clu = dp->sclust;
		Files[i].idx = dp->index;
		Files[i].ctr = 0;
	}

	if (acc && Files[i].ctr) return 0;	/* ᔽ(ُ) */

	Files[i].ctr = acc ? 0x100 : Files[i].ctr + 1;	/* ̫lݒ */

	return i + 1;
}

static
FRESULT dec_lock (	/* Ώەv */
	UINT i			/* ̫wW (1..) */
)
{
	WORD n;
	FRESULT res;

	if (--i < _FS_LOCK) {	/* wWԍ0ֈړ */
		n = Files[i].ctr;
		if (n == 0x100) n = 0;		/* ݓȂA폜 */
		if (n) n--;					/* ǂݍݓv */
		Files[i].ctr = n;
		if (!n) Files[i].fs = 0;	/* v킪0Ȃ폜 */
		res = FR_OK;
	} else {
		res = FR_INT_ERR;			/* wWԍ */
	}
	return res;
}

static
void clear_lock (	/* حт̎{ */
	FATFS *fs
)
{
	UINT i;

	for (i = 0; i < _FS_LOCK; i++) {
		if (Files[i].fs == fs) Files[i].fs = 0;
	}
}
#endif

/*-----------------------------------------------------------------------*/
/* ̧ ёΏەި ړ/o                          */
/*-----------------------------------------------------------------------*/
#if !_FS_READONLY
static
FRESULT sync_window (	/* FR_OK:, !=0:ُ */
	FATFS* fs			/* ̧ ёΏە */
)
{
	DWORD wsect;
	UINT nf;
	FRESULT res = FR_OK;


	if (fs->wflag) {	/* ꂪωž߂ */
		wsect = fs->winsect;	/* ݂̾ԍ */
		if (disk_write(fs->drv, fs->win, wsect, 1) != RES_OK) {
			res = FR_DISK_ERR;
		} else {
			fs->wflag = 0;
			if (wsect - fs->fatbase < fs->fsize) {		/* FAT̈悩? */
				for (nf = fs->n_fats; nf >= 2; nf--) {	/* SFATɕύX𔽉f */
					wsect += fs->fsize;
					disk_write(fs->drv, fs->win, wsect, 1);
				}
			}
		}
	}
	return res;
}
#endif

static
FRESULT move_window (	/* FR_OK(0):, !=0:ُ */
	FATFS* fs,		/* ̧ ёΏە */
	DWORD sector	/* fs->win[]ŏo邽߂ɾԍ */
)
{
	FRESULT res = FR_OK;

	if (sector != fs->winsect) {	/* ψʕύX? */
#if !_FS_READONLY
		res = sync_window(fs);		/* ύX߂ */
#endif
		if (res == FR_OK) {			/* VKްž𖞂 */
			if (disk_read(fs->drv, fs->win, sector, 1) != RES_OK) {
				sector = 0xFFFFFFFF;	/* ްMłȂꍇ͖ */
				res = FR_DISK_ERR;
			}
			fs->winsect = sector;
		}
	}
	return res;
}

/*-----------------------------------------------------------------------*/
/* ̧ тƋLu𓯊                                             */
/*-----------------------------------------------------------------------*/
#if !_FS_READONLY
static
FRESULT sync_fs (	/* FR_OK:, !=0:ُ */
	FATFS* fs		/* ̧ ёΏە */
)
{
	FRESULT res;

	res = sync_window(fs);
	if (res == FR_OK) {
		/* KvȂAFSInfoXV */
		if (fs->fs_type == FS_FAT32 && fs->fsi_flag == 1) {
			/* FSInfo\̍쐬 */
			mem_set(fs->win, 0, SS(fs));
			ST_WORD(fs->win + BS_55AA, 0xAA55);
			ST_DWORD(fs->win + FSI_LeadSig, 0x41615252);
			ST_DWORD(fs->win + FSI_StrucSig, 0x61417272);
			ST_DWORD(fs->win + FSI_Free_Count, fs->free_clust);
			ST_DWORD(fs->win + FSI_Nxt_Free, fs->last_clust);
			/* FSInfoɂ */
			fs->winsect = fs->volbase + 1;
			disk_write(fs->drv, fs->win, fs->winsect, 1);
			fs->fsi_flag = 0;
		}
		/* ײނŕۗݏȂƂۏ */
		if (disk_ioctl(fs->drv, CTRL_SYNC, 0) != RES_OK)
			res = FR_DISK_ERR;
	}

	return res;
}
#endif

/*-----------------------------------------------------------------------*/
/* ׽ԍ羸ԍ擾                                             */
/*-----------------------------------------------------------------------*/
/* Əpި °ٗpBAPI */

DWORD clust2sect (	/* !=0:ԍ, 0:s(ԍ) */
	FATFS* fs,		/* ̧ ёΏە */
	DWORD clst		/* ϊׂ׽ԍ */
)
{
	clst -= 2;
	if (clst >= fs->n_fatent - 2) return 0;		/* ׽ԍ */
	return clst * fs->csize + fs->database;
}

/*-----------------------------------------------------------------------*/
/* FAT - FAT̓ǂݍݒl                                         */
/*-----------------------------------------------------------------------*/
/* Əpި °ٗpBAPI */

DWORD get_fat (	/* 0xFFFFFFFF:ިُ, 1:ُ, 2..0x0FFFFFFF: */
	FATFS* fs,	/* ̧ ёΏە */
	DWORD clst	/* l𓾂邽߂FATwWԍ(׽ԍ) */
)
{
	UINT wc, bc;
	BYTE *p;
	DWORD val;


	if (clst < 2 || clst >= fs->n_fatent) {	/* L͈͂ */
		val = 1;	/* ُ */

	} else {
		val = 0xFFFFFFFF;	/* ިُɂȂl */

		switch (fs->fs_type) {
		case FS_FAT12 :
			bc = (UINT)clst; bc += bc / 2;
			if (move_window(fs, fs->fatbase + (bc / SS(fs))) != FR_OK) break;
			wc = fs->win[bc++ % SS(fs)];
			if (move_window(fs, fs->fatbase + (bc / SS(fs))) != FR_OK) break;
			wc |= fs->win[bc % SS(fs)] << 8;
			val = clst & 1 ? wc >> 4 : (wc & 0xFFF);
			break;

		case FS_FAT16 :
			if (move_window(fs, fs->fatbase + (clst / (SS(fs) / 2))) != FR_OK) break;
			p = &fs->win[clst * 2 % SS(fs)];
			val = LD_WORD(p);
			break;

		case FS_FAT32 :
			if (move_window(fs, fs->fatbase + (clst / (SS(fs) / 4))) != FR_OK) break;
			p = &fs->win[clst * 4 % SS(fs)];
			val = LD_DWORD(p) & 0x0FFFFFFF;
			break;

		default:
			val = 1;	/* ُ */
		}
	}

	return val;
}

/*-----------------------------------------------------------------------*/
/* FAT - FAT̒lύX                                           */
/*-----------------------------------------------------------------------*/
/* Əpި °ٗpBAPI */

#if !_FS_READONLY
FRESULT put_fat (	/* FR_OK(0):, !=0:ُ */
	FATFS* fs,		/* ̧ ёΏە */
	DWORD clst,		/* ύXׂFATwWԍ(׽ԍ) */
	DWORD val		/* ɐݒ肳ׂVl */
)
{
	UINT bc;
	BYTE *p;
	FRESULT res;


	if (clst < 2 || clst >= fs->n_fatent) {	/* LȔ͈͂ */
		res = FR_INT_ERR;

	} else {
		switch (fs->fs_type) {
		case FS_FAT12 :
			bc = (UINT)clst; bc += bc / 2;
			res = move_window(fs, fs->fatbase + (bc / SS(fs)));
			if (res != FR_OK) break;
			p = &fs->win[bc++ % SS(fs)];
			*p = (clst & 1) ? ((*p & 0x0F) | ((BYTE)val << 4)) : (BYTE)val;
			fs->wflag = 1;
			res = move_window(fs, fs->fatbase + (bc / SS(fs)));
			if (res != FR_OK) break;
			p = &fs->win[bc % SS(fs)];
			*p = (clst & 1) ? (BYTE)(val >> 4) : ((*p & 0xF0) | ((BYTE)(val >> 8) & 0x0F));
			fs->wflag = 1;
			break;

		case FS_FAT16 :
			res = move_window(fs, fs->fatbase + (clst / (SS(fs) / 2)));
			if (res != FR_OK) break;
			p = &fs->win[clst * 2 % SS(fs)];
			ST_WORD(p, (WORD)val);
			fs->wflag = 1;
			break;

		case FS_FAT32 :
			res = move_window(fs, fs->fatbase + (clst / (SS(fs) / 4)));
			if (res != FR_OK) break;
			p = &fs->win[clst * 4 % SS(fs)];
			val |= LD_DWORD(p) & 0xF0000000;
			ST_DWORD(p, val);
			fs->wflag = 1;
			break;

		default :
			res = FR_INT_ERR;
		}
	}

	return res;
}
#endif /* !_FS_READONLY */

/*-----------------------------------------------------------------------*/
/* FAT - ׽A苎                                          */
/*-----------------------------------------------------------------------*/
#if !_FS_READONLY
static
FRESULT remove_chain (	/* FR_OK(0):, !=0:ُ */
	FATFS* fs,			/* ̧ ёΏە */
	DWORD clst			/* A苎׽ԍ */
)
{
	FRESULT res;
	DWORD nxt;
#if _USE_TRIM
	DWORD scl = clst, ecl = clst, rt[2];
#endif

	if (clst < 2 || clst >= fs->n_fatent) {	/* LȔ͈͂ */
		res = FR_INT_ERR;

	} else {
		res = FR_OK;
		while (clst < fs->n_fatent) {			/* Ō̐ڑłȂ? */
			nxt = get_fat(fs, clst);			/* ׽Ԏ擾 */
			if (nxt == 0) break;				/* ׽? */
			if (nxt == 1) { res = FR_INT_ERR; break; }	/* ُ? */
			if (nxt == 0xFFFFFFFF) { res = FR_DISK_ERR; break; }	/* ިُ? */
			res = put_fat(fs, clst, 0);			/* ׽""ɋL */
			if (res != FR_OK) break;
			if (fs->free_clust != 0xFFFFFFFF) {	/* FSINFOXV */
				fs->free_clust++;
				fs->fsi_flag |= 1;
			}
#if _USE_TRIM
			if (ecl + 1 == nxt) {	/* ̸׽͗אڂ? */
				ecl = nxt;
			} else {				/* אڸ׽̏I */ 
				rt[0] = clust2sect(fs, scl);					/* Jn */
				rt[1] = clust2sect(fs, ecl) + fs->csize - 1;	/* I */
				disk_ioctl(fs->drv, CTRL_TRIM, rt);				/*  */
				scl = ecl = nxt;
			}
#endif
			clst = nxt;	/* ̸׽ */
		}
	}

	return res;
}
#endif

/*-----------------------------------------------------------------------*/
/* FAT - ׽A̐L܂͍쐬                                    */
/*-----------------------------------------------------------------------*/
#if !_FS_READONLY
static
DWORD create_chain (	/* 0:󂫸׽, 1:ُ, 0xFFFFFFFF:ިُ, >=2:V׽ԍ */
	FATFS* fs,			/* ̧ ёΏە */
	DWORD clst			/* L׽ԍA0:VA쐬 */
)
{
	DWORD cs, ncl, scl;
	FRESULT res;

	if (clst == 0) {		/* VKA쐬 */
		scl = fs->last_clust;			/* ĂꂽJnʒu擾 */
		if (!scl || scl >= fs->n_fatent) scl = 1;
	}
	else {					/* ݂̘AL */
		cs = get_fat(fs, clst);			/* ׽Ԍ */
		if (cs < 2) return 1;			/* l */
		if (cs == 0xFFFFFFFF) return cs;	/* ިُ픭 */
		if (cs < fs->n_fatent) return cs;	/* Ɏ̸׽ɂČp */
		scl = clst;
	}

	ncl = scl;				/* Jn׽ */
	for (;;) {
		ncl++;							/* ̸׽ */
		if (ncl >= fs->n_fatent) {		/* ۂߌ */
			ncl = 2;
			if (ncl > scl) return 0;	/* 󂫸׽Ȃ */
		}
		cs = get_fat(fs, ncl);			/* ׽Ԏ擾 */
		if (cs == 0) break;				/* 󂫸׽ */
		if (cs == 0xFFFFFFFF || cs == 1)/* ُ픭 */
			return cs;
		if (ncl == scl) return 0;		/* 󂫸׽Ȃ */
	}

	res = put_fat(fs, ncl, 0x0FFFFFFF);	/* V׽"ŏIڑ"ɋL */
	if (res == FR_OK && clst != 0) {
		res = put_fat(fs, clst, ncl);	/* KvȂAO̕ɐڑ */
	}
	if (res == FR_OK) {
		fs->last_clust = ncl;			/* FSINFOXV */
		if (fs->free_clust != 0xFFFFFFFF) {
			fs->free_clust--;
			fs->fsi_flag |= 1;
		}
	} else {
		ncl = (res == FR_DISK_ERR) ? 0xFFFFFFFF : 1;
	}

	return ncl;		/* V׽ԍ܂ُ͈필ԂB */
}
#endif /* !_FS_READONLY */

/*-----------------------------------------------------------------------*/
/* FAT - ψʂڑ蓖ĕ\ł̸׽ɕϊ                          */
/*-----------------------------------------------------------------------*/

#if _USE_FASTSEEK
static
DWORD clmt_clust (	/* <2:ُ, >=2:׽ԍ */
	FIL* fp,		/* ّ̧Ώەւ̈ʒuwq */
	DWORD ofs		/* ׽ԍɕϊׂ̧ٕψ */
)
{
	DWORD cl, ncl, *tbl;

	tbl = fp->cltbl + 1;	/* CLMT̐擪 */
	cl = ofs / SS(fp->fs) / fp->fs->csize;	/* ِ̧擪̸׽ */
	for (;;) {
		ncl = *tbl++;			/* fЉ׽ */
		if (!ncl) return 0;		/* \I? (ُ) */
		if (cl < ncl) break;	/* fЉ? */
		cl -= ncl; tbl++;		/* f */
	}
	return cl + *tbl;	/* ׽ԍԂB */
}
#endif	/* _USE_FASTSEEK */

/*-----------------------------------------------------------------------*/
/* ިڸ؏ - ިڸ؎wWݒ                                         */
/*-----------------------------------------------------------------------*/

static
FRESULT dir_sdi (	/* FR_OK(0):, !=0:ُ */
	DIR* dp,		/* ިڸؑΏەւ̈ʒuwq */
	UINT idx		/* ިڸؕ\̎wW */
)
{
	DWORD clst, sect;
	UINT ic;

	dp->index = (WORD)idx;	/* ݂̎wW */
	clst = dp->sclust;		/* \̊Jn׽ (0:{) */
	if (clst == 1 || clst >= dp->fs->n_fatent)	/* Jn׽͈͌ */
		return FR_INT_ERR;
	if (!clst && dp->fs->fs_type == FS_FAT32)	/* FAT32ȂA׽ԍ0{׽ԍ0Œu */
		clst = dp->fs->dirbase;

	if (clst == 0) {	/* ÓIȕ\(FAT12/16ł̍{ިڸ) */
		if (idx >= dp->fs->n_rootdir)	/* wW͈͊O? */
			return FR_INT_ERR;
		sect = dp->fs->dirbase;
	}
	else {				/* Iȕ\(FAT32܂͕ިڸ؂ł̍{ިڸ) */
		ic = SS(dp->fs) / SZ_DIRE * dp->fs->csize;	/* ׽̓ */
		while (idx >= ic) {	/* 㑱׽A */
			clst = get_fat(dp->fs, clst);				/* ̸׽擾 */
			if (clst == 0xFFFFFFFF) return FR_DISK_ERR;	/* ިُ */
			if (clst < 2 || clst >= dp->fs->n_fatent)	/* \̍ŌɓB܂ُ͓ */
				return FR_INT_ERR;
			idx -= ic;
		}
		sect = clust2sect(dp->fs, clst);
	}
	dp->clust = clst;	/* ̸݂׽ԍ */
	if (!sect) return FR_INT_ERR;
	dp->sect = sect + idx / (SS(dp->fs) / SZ_DIRE);					/* ިڸؓ̾ԍ */
	dp->dir = dp->fs->win + (idx % (SS(dp->fs) / SZ_DIRE)) * SZ_DIRE;	/* ̓ւ̈ʒuwq */

	return FR_OK;
}

/*-----------------------------------------------------------------------*/
/* ިڸؑ - ިڸؕ\̎wWֈړ                               */
/*-----------------------------------------------------------------------*/

static
FRESULT dir_next (	/* FR_OK(0):, FR_NO_FILE:\I, FR_DENIED:Ls */
	DIR* dp,		/* ިڸؑΏەւ̈ʒuwq */
	int stretch		/* 0:\LȂ, 1: KvȂA\L */
)
{
	DWORD clst;
	UINT i;
#if !_FS_READONLY
	UINT c;
#endif

	i = dp->index + 1;
	if (!(i & 0xFFFF) || !dp->sect)	/* wW65535BEOT */
		return FR_NO_FILE;

	if (!(i % (SS(dp->fs) / SZ_DIRE))) {	/* ύX? */
		dp->sect++;					/*  */

		if (!dp->clust) {		/* ÓIȕ\ */
			if (i >= dp->fs->n_rootdir)	/* ÓIȕ\̍ŌɓBꍇEOT */
				return FR_NO_FILE;
		}
		else {					/* Iȕ\ */
			if (((i / (SS(dp->fs) / SZ_DIRE)) & (dp->fs->csize - 1)) == 0) {	/* ׽ύX? */
				clst = get_fat(dp->fs, dp->clust);				/* ׽擾 */
				if (clst <= 1) return FR_INT_ERR;
				if (clst == 0xFFFFFFFF) return FR_DISK_ERR;
				if (clst >= dp->fs->n_fatent) {					/* Iȕ\̍ŌɓBꍇA */
#if !_FS_READONLY
					if (!stretch) return FR_NO_FILE;			/* LȂȂAEOT */
					clst = create_chain(dp->fs, dp->clust);		/* ׽AL */
					if (clst == 0) return FR_DENIED;			/* 󂫸׽Ȃ */
					if (clst == 1) return FR_INT_ERR;
					if (clst == 0xFFFFFFFF) return FR_DISK_ERR;
					/* Clean-up stretched table */
					if (sync_window(dp->fs)) return FR_DISK_ERR;/* ި o */
					mem_set(dp->fs->win, 0, SS(dp->fs));		/* ɏՕ */
					dp->fs->winsect = clust2sect(dp->fs, clst);	/* ׽Jn */
					for (c = 0; c < dp->fs->csize; c++) {		/* V׽0ŖB */
						dp->fs->wflag = 1;
						if (sync_window(dp->fs)) return FR_DISK_ERR;
						dp->fs->winsect++;
					}
					dp->fs->winsect -= c;						/* ψʂ߂B */
#else
					if (!stretch) return FR_NO_FILE;			/* LȂȂAEOT(͌x) */
					return FR_NO_FILE;							/* EOT */
#endif
				}
				dp->clust = clst;				/* V׽ɑ΂ް */
				dp->sect = clust2sect(dp->fs, clst);
			}
		}
	}

	dp->index = (WORD)i;	/* ݂̎wW */
	dp->dir = dp->fs->win + (i % (SS(dp->fs) / SZ_DIRE)) * SZ_DIRE;	/* ݂̌̓ */

	return FR_OK;
}

/*-----------------------------------------------------------------------*/
/* ިڸؑ - ިڸؓ\                                         */
/*-----------------------------------------------------------------------*/

#if !_FS_READONLY
static
FRESULT dir_alloc (	/* FR_OK(0):, !=0:ُ */
	DIR* dp,		/* ިڸؑΏەւ̈ʒuwq */
	UINT nent		/* 蓖Ă̂߂̘A (1-21) */
)
{
	FRESULT res;
	UINT n;

	res = dir_sdi(dp, 0);
	if (res == FR_OK) {
		n = 0;
		do {
			res = move_window(dp->fs, dp->sect);
			if (res != FR_OK) break;
			if (dp->dir[0] == DDEM || dp->dir[0] == 0) {	/* 󂫓? */
				if (++n == nent) break;	/* A󂫓̉򔭌 */
			} else {
				n = 0;					/* 󂫓ȊOAĊJ */
			}
			res = dir_next(dp, 1);		/* \LŎ */
		} while (res == FR_OK);
	}
	if (res == FR_NO_FILE) res = FR_DENIED;	/* 蓖Ă̂߂ިڸؓȂ */
	return res;
}
#endif

/*-----------------------------------------------------------------------*/
/* ިڸؑ - Jn׽ԍ擾/i[                                   */
/*-----------------------------------------------------------------------*/

static
DWORD ld_clust (	/* SFN̐擪׽lԂB */
	FATFS* fs,		/* fsΏەւ̈ʒuwq */
	const BYTE* dir	/* SFNւ̈ʒuwq */
)
{
	DWORD cl;

	cl = LD_WORD(dir + DIR_FstClusLO);
	if (fs->fs_type == FS_FAT32)
		cl |= (DWORD)LD_WORD(dir + DIR_FstClusHI) << 16;

	return cl;
}

#if !_FS_READONLY
static
void st_clust (
	BYTE* dir,	/* SFNւ̈ʒuwq */
	DWORD cl	/* ݒ肳ׂl */
)
{
	ST_WORD(dir + DIR_FstClusLO, cl);
	ST_WORD(dir + DIR_FstClusHI, cl >> 16);
}
#endif

/*-----------------------------------------------------------------------*/
/* LFN - LFNĂިڸؓ̌/̎/K                      */
/*-----------------------------------------------------------------------*/
#if _USE_LFN
static
const BYTE LfnOfs[] = {1,3,5,7,9,14,16,18,20,22,24,28,30};	/* ިڸؓLFN̕ψ */


static
int cmp_lfn (			/* 1:v, 0:sv */
	WCHAR* lfnbuf,		/* rׂLFNƊɏՕւ̈ʒuwq */
	BYTE* dir			/* LFN̕܂ިڸؓւ̈ʒuwq */
)
{
	UINT i, s;
	WCHAR wc, uc;

	if (LD_WORD(dir + LDIR_FstClusLO) != 0) return 0;	/* LDIR_FstClusLO */

	i = ((dir[LDIR_Ord] & 0x3F) - 1) * 13;	/* LFNɏՕ̕ψ */

	for (wc = 1, s = 0; s < 13; s++) {		/* ̑S */
		uc = LD_WORD(dir + LfnOfs[s]);		/* LFN̎ */
		if (wc) {
			if (i >= _MAX_LFN || ff_wtoupper(uc) != ff_wtoupper(lfnbuf[i++]))	/* r */
				return 0;					/* sv */
			wc = uc;
		} else {
			if (uc != 0xFFFF) return 0;		/* [U */
		}
	}

	if ((dir[LDIR_Ord] & LLEF) && wc && lfnbuf[i])	/* ŏIĈvAقȂ钷 */
		return 0;

	return 1;		/* LFNv */
}

static
int pick_lfn (			/* 1:, 0:ɏՕ܂͖LFN */
	WCHAR* lfnbuf,		/* LFNƊɏՕւ̈ʒuwq */
	BYTE* dir			/* LFNւ̈ʒuwq */
)
{
	UINT i, s;
	WCHAR wc, uc;

	if (LD_WORD(dir + LDIR_FstClusLO) != 0) return 0;	/* LDIR_FstClusLO */

	i = ((dir[LDIR_Ord] & 0x3F) - 1) * 13;	/* LFNɏՕ̕ψ */

	for (wc = 1, s = 0; s < 13; s++) {		/* ̑S */
		uc = LD_WORD(dir + LfnOfs[s]);		/* LFN̎ */
		if (wc) {
			if (i >= _MAX_LFN) return 0;	/* ɏՕꂩ? */
			lfnbuf[i++] = wc = uc;			/* i[ */
		} else {
			if (uc != 0xFFFF) return 0;		/* [U */
		}
	}

	if (dir[LDIR_Ord] & LLEF) {				/* ꂪŏILFNȂAIqzu */
		if (i >= _MAX_LFN) return 0;		/* ɏՕꂩ? */
		lfnbuf[i] = 0;
	}

	return 1;		/* LFN͗L */
}

#if !_FS_READONLY
static
void fit_lfn (
	const WCHAR* lfnbuf,	/* LFNƊɏՕւ̈ʒuwq */
	BYTE* dir,				/* ׂLFNւ̈ʒuwq */
	BYTE ord,				/* LFN (1-20) */
	BYTE sum				/* ΉSFN */
)
{
	UINT i, s;
	WCHAR wc;

	dir[LDIR_Chksum] = sum;			/* ѐݒ */
	dir[LDIR_Attr] = AM_LFN;		/* LFNɐݒ */
	dir[LDIR_Type] = 0;
	ST_WORD(dir + LDIR_FstClusLO, 0);

	i = (ord - 1) * 13;				/* LFNƊɏՕ̕ψʎ擾 */
	s = wc = 0;
	do {
		if (wc != 0xFFFF) wc = lfnbuf[i++];	/* 擾 */
		ST_WORD(dir+LfnOfs[s], wc);	/* zu */
		if (!wc) wc = 0xFFFF;		/* ŏIȍ~𕶎Ō */
	} while (++s < 13);
	if (wc == 0xFFFF || !lfnbuf[i]) ord |= LLEF;	/* LFN̊LFN̘ÅJn */
	dir[LDIR_Ord] = ord;			/* LFN̐ݒ */
}

#endif
#endif

/*-----------------------------------------------------------------------*/
/* ԍtꂽO쐬                                              */
/*-----------------------------------------------------------------------*/
#if _USE_LFN
static
void gen_numname (
	BYTE* dst,			/* ԍtꂽSFNi[邽߂̊ɏՕւ̈ʒuwq */
	const BYTE* src,	/* SFNւ̈ʒuwq */
	const WCHAR* lfn,	/* LFNւ̈ʒuwq */
	UINT seq			/* ʂԍ */
)
{
	BYTE ns[8], c;
	UINT i, j;
	WCHAR wc;
	DWORD sr;

	mem_cpy(dst, src, 11);

	if (seq > 5) {	/* ̏Փ˂ŁAʔԂɑウʯԍ𐶐 */
		sr = seq;
		while (*lfn) {	/* CRC쐬 */
			wc = *lfn++;
			for (i = 0; i < 16; i++) {
				sr = (sr << 1) + (wc & 1);
				wc >>= 1;
				if (sr & 0x10000) sr ^= 0x11021;
			}
		}
		seq = (UINT)sr;
	}

	/* l˕ϊ (16i) */
	i = 7;
	do {
		c = (seq % 16) + '0';
		if (c > '9') c += 7;
		ns[i--] = c;
		seq /= 16;
	} while (seq);
	ns[i] = '~';

	/* ԍǉ */
	for (j = 0; j < i && dst[j] != ' '; j++) {
		if (IsDBCS1(dst[j])) {
			if (j == i - 1) break;
			j++;
		}
	}
	do {
		dst[j++] = (i < 8) ? ns[i++] : ' ';
	} while (j < 8);
}
#endif

/*-----------------------------------------------------------------------*/
/* SFNьvZ                                                   */
/*-----------------------------------------------------------------------*/
#if _USE_LFN
static
BYTE sum_sfn (
	const BYTE* dir		/* SFNւ̈ʒuwq */
)
{
	BYTE sum = 0;
	UINT n = 11;

	do sum = (sum >> 1) + (sum << 7) + *dir++; while (--n);
	return sum;
}
#endif

/*-----------------------------------------------------------------------*/
/* ިڸؑ - ިڸ؂őΏە                                   */
/*-----------------------------------------------------------------------*/

static
FRESULT dir_find (	/* FR_OK(0):, !=0:ُ */
	DIR* dp			/* ̧ٖɌqިڸؑΏەւ̈ʒuwq */
)
{
	FRESULT res;
	BYTE c, *dir;
#if _USE_LFN
	BYTE a, ord, sum;
#endif

	res = dir_sdi(dp, 0);			/* ިڸؑΏە߂B */
	if (res != FR_OK) return res;

#if _USE_LFN
	ord = sum = 0xFF; dp->lfn_idx = 0xFFFF;	/* LFNAؾ */
#endif
	do {
		res = move_window(dp->fs, dp->sect);
		if (res != FR_OK) break;
		dir = dp->dir;					/* ݂̎wWިڸؓւ̈ʒuwq */
		c = dir[DIR_Name];
		if (c == 0) { res = FR_NO_FILE; break; }	/* \̍ŌɓB */
#if _USE_LFN	/* LFN`Ԑݒ */
		a = dir[DIR_Attr] & AM_MASK;
		if (c == DDEM || ((a & AM_VOL) && a != AM_LFN)) {	/* LްȂ */
			ord = 0xFF; dp->lfn_idx = 0xFFFF;	/* LFNAؾ */
		} else {
			if (a == AM_LFN) {			/* LFN */
				if (dp->lfn) {
					if (c & LLEF) {		/* LFNÅJn? */
						sum = dir[LDIR_Chksum];
						c &= ~LLEF; ord = c;	/* LFNJn */
						dp->lfn_idx = dp->index;	/* LFN̎wWJn */
					}
					/* LFN̗LƗ^ꂽOƂ̔r */
					ord = (c == ord && sum == dir[LDIR_Chksum] && cmp_lfn(dp->lfn, dir)) ? ord - 1 : 0xFF;
				}
			} else {					/* SFN */
				if (!ord && sum == sum_sfn(dir)) break;	/* LFNv? */
				if (!(dp->fn[NSFLAG] & NS_LOSS) && !mem_cmp(dir, dp->fn, 11)) break;	/* SFNv? */
				ord = 0xFF; dp->lfn_idx = 0xFFFF;	/* LFNAؾ */
			}
		}
#else		/* LFN`Ԑݒ */
		if (!(dir[DIR_Attr] & AM_VOL) && !mem_cmp(dir, dp->fn, 11)) /* L? */
			break;
#endif
		res = dir_next(dp, 0);		/* ̓ */
	} while (res == FR_OK);

	return res;
}

/*-----------------------------------------------------------------------*/
/* ިڸ؂Ώەǂݍ                                           */
/*-----------------------------------------------------------------------*/
#if _FS_MINIMIZE <= 1 || _USE_LABEL || _FS_RPATH >= 2
static
FRESULT dir_read (
	DIR* dp,		/* ިڸؑΏەւ̈ʒuwq */
	int vol			/* ȉɂh 0:̧/ިڸ ܂ 1:ح  */
)
{
	FRESULT res;
	BYTE a, c, *dir;
#if _USE_LFN
	BYTE ord = 0xFF, sum = 0xFF;
#endif

	res = FR_NO_FILE;
	while (dp->sect) {
		res = move_window(dp->fs, dp->sect);
		if (res != FR_OK) break;
		dir = dp->dir;					/* ݂̎wWިڸؓւ̈ʒuwq */
		c = dir[DIR_Name];
		if (c == 0) { res = FR_NO_FILE; break; }	/* \̍ŌɓB */
		a = dir[DIR_Attr] & AM_MASK;
#if _USE_LFN	/* LFN`Ԑݒ */
		if (c == DDEM || (!_FS_RPATH && c == '.') || (int)((a & ~AM_ARC) == AM_VOL) != vol) {	/* LްȂ */
			ord = 0xFF;
		} else {
			if (a == AM_LFN) {			/* LFN */
				if (c & LLEF) {			/* LFNÅJn? */
					sum = dir[LDIR_Chksum];
					c &= ~LLEF; ord = c;
					dp->lfn_idx = dp->index;
				}
				/* LFNLƕߊl */
				ord = (c == ord && sum == dir[LDIR_Chksum] && pick_lfn(dp->lfn, dir)) ? ord - 1 : 0xFF;
			} else {					/* SFN */
				if (ord || sum != sum_sfn(dir))	/* LLFNL邩? */
					dp->lfn_idx = 0xFFFF;		/* LFNȂ */
				break;
			}
		}
#else		/* LFN`Ԑݒ */
		if (c != DDEM && (_FS_RPATH || c != '.') && a != AM_LFN && (int)((a & ~AM_ARC) == AM_VOL) == vol)	/* Lȓ? */
			break;
#endif
		res = dir_next(dp, 0);				/* ̓ */
		if (res != FR_OK) break;
	}

	if (res != FR_OK) dp->sect = 0;

	return res;
}
#endif	/* _FS_MINIMIZE <= 1 || _USE_LABEL || _FS_RPATH >= 2 */

/*-----------------------------------------------------------------------*/
/* ިڸ؂ɑΏەo^                                                 */
/*-----------------------------------------------------------------------*/
#if !_FS_READONLY
static
FRESULT dir_register (	/* FR_OK:, FR_DENIED:󂫓Ȃ܂͑SFNՓ, FR_DISK_ERR:ިُ */
	DIR* dp				/* 쐬ׂΏە̖OړIΏިڸ */
)
{
	FRESULT res;
#if _USE_LFN	/* LFN`Ԑݒ */
	UINT n, nent;
	BYTE sn[12], *fn, sum;
	WCHAR *lfn;


	fn = dp->fn; lfn = dp->lfn;
	mem_cpy(sn, fn, 12);

	if (_FS_RPATH && (sn[NSFLAG] & NS_DOT))		/* _쐬s\ */
		return FR_INVALID_NAME;

	if (sn[NSFLAG] & NS_LOSS) {			/* LFN8.3`ȊOAԍtꂽO쐬 */
		fn[NSFLAG] = 0; dp->lfn = 0;			/* SFN{B */
		for (n = 1; n < 100; n++) {
			gen_numname(fn, sn, lfn, n);	/* ԍtꂽO쐬 */
			res = dir_find(dp);				/* OSFNƏՓ˂Ȃ */
			if (res != FR_OK) break;
		}
		if (n == 100) return FR_DENIED;		/* Փ˂̏ꍇɒf */
		if (res != FR_NO_FILE) return res;	/* ʂ'Փ'ȊȌꍇɒf */
		fn[NSFLAG] = sn[NSFLAG]; dp->lfn = lfn;
	}

	if (sn[NSFLAG] & NS_LFN) {			/* LFN쐬ׂSFN+LFNsɑ΂ē蓖 */
		for (n = 0; lfn[n]; n++) ;
		nent = (n + 25) / 13;
	} else {						/* ȂSFNɑ΂ē蓖 */
		nent = 1;
	}
	res = dir_alloc(dp, nent);		/* 蓖 */

	if (res == FR_OK && --nent) {	/* KvƂꍇLFNݒ */
		res = dir_sdi(dp, dp->index - nent);
		if (res == FR_OK) {
			sum = sum_sfn(dp->fn);	/* SFNђlLFNɌ */
			do {					/* 擪LFNi[ */
				res = move_window(dp->fs, dp->sect);
				if (res != FR_OK) break;
				fit_lfn(dp->lfn, dp->dir, (BYTE)nent, sum);
				dp->fs->wflag = 1;
				res = dir_next(dp, 0);	/* ̓ */
			} while (res == FR_OK && --nent);
		}
	}
#else	/* LFN`Ԑݒ */
	res = dir_alloc(dp, 1);		/* SFNɑ΂ē蓖 */
#endif

	if (res == FR_OK) {				/* SFNݒ */
		res = move_window(dp->fs, dp->sect);
		if (res == FR_OK) {
			mem_set(dp->dir, 0, SZ_DIRE);	/*  */
			mem_cpy(dp->dir, dp->fn, 11);	/* SFNzu */
#if _USE_LFN
			dp->dir[DIR_NTres] = dp->fn[NSFLAG] & (NS_BODY | NS_EXT);	/* NT׸ނzu */
#endif
			dp->fs->wflag = 1;
		}
	}

	return res;
}
#endif /* !_FS_READONLY */

/*-----------------------------------------------------------------------*/
/* ިڸ؂Ώە                                               */
/*-----------------------------------------------------------------------*/
#if !_FS_READONLY && !_FS_MINIMIZE
static
FRESULT dir_remove (	/* FR_OK:, FR_DISK_ERR:ިُ */
	DIR* dp				/* ׂިڸؑΏە */
)
{
	FRESULT res;
#if _USE_LFN	/* LFN`Ԑݒ */
	UINT i;

	i = dp->index;	/* SFNwW */
	res = dir_sdi(dp, (dp->lfn_idx == 0xFFFF) ? i : dp->lfn_idx);	/* SFN܂LFN擪֍sB */
	if (res == FR_OK) {
		do {
			res = move_window(dp->fs, dp->sect);
			if (res != FR_OK) break;
			mem_set(dp->dir, 0, SZ_DIRE);	/* "폜ς"ƋLB */
			*dp->dir = DDEM;
			dp->fs->wflag = 1;
			if (dp->index >= i) break;	/* SFNBAΏە̑S폜 */
			res = dir_next(dp, 0);		/* ̓ */
		} while (res == FR_OK);
		if (res == FR_NO_FILE) res = FR_INT_ERR;
	}

#else			/* LFN`Ԑݒ */
	res = dir_sdi(dp, dp->index);
	if (res == FR_OK) {
		res = move_window(dp->fs, dp->sect);
		if (res == FR_OK) {
			mem_set(dp->dir, 0, SZ_DIRE);	/* "폜ς"ƋLB */
			*dp->dir = DDEM;
			dp->fs->wflag = 1;
		}
	}
#endif

	return res;
}
#endif /* !_FS_READONLY */

/*-----------------------------------------------------------------------*/
/* ިڸُ̧ؓ擾                                         */
/*-----------------------------------------------------------------------*/
#if _FS_MINIMIZE <= 1 || _FS_RPATH >= 2
static
void get_fileinfo (		/* ԂȂ */
	DIR* dp,			/* ިڸؑΏەւ̈ʒuwq */
	FILINFO* fno	 	/* ׂُ̧ւ̈ʒuwq */
)
{
	UINT i;
	TCHAR *p, c;
	BYTE *dir;
#if _USE_LFN
	WCHAR w, *lfn;
#endif

	p = fno->fname;
	if (dp->sect) {		/* SFN擾 */
		dir = dp->dir;
		i = 0;
		while (i < 11) {		/* O{̂Ɗg𕡎 */
			c = (TCHAR)dir[i++];
			if (c == ' ') continue;				/* ߋ󔒔΂ */
			if (c == RDDEM) c = (TCHAR)DDEM;	/* uꂽDDEM */
			if (i == 9) *p++ = '.';				/* gq݂ȂA'.'} */
#if _USE_LFN
			if (IsUpper(c) && (dir[DIR_NTres] & (i >= 9 ? NS_EXT : NS_BODY)))
				c += 0x20;			/*  */
#if _LFN_UNICODE
			if (IsDBCS1(c) && i != 8 && i != 11 && IsDBCS2(dir[i]))
				c = c << 8 | dir[i++];
			c = ff_convert(c, 1);	/* OEMUnicode */
			if (!c) c = '?';
#endif
#endif
			*p++ = c;
		}
		fno->fattrib = dir[DIR_Attr];				/*  */
		fno->fsize = LD_DWORD(dir + DIR_FileSize);	/* 傫 */
		fno->fdate = LD_WORD(dir + DIR_WrtDate);	/* t */
		fno->ftime = LD_WORD(dir + DIR_WrtTime);	/*  */
	}
	*p = 0;		/* \0ɂSFNI */

#if _USE_LFN
	if (fno->lfname) {
		i = 0; p = fno->lfname;
		if (dp->sect && fno->lfsize && dp->lfn_idx != 0xFFFF) {	/* p\ȂALFN擾 */
			lfn = dp->lfn;
			while ((w = *lfn++) != 0) {		/* LFN擾 */
#if !_LFN_UNICODE
				w = ff_convert(w, 0);		/* UnicodeOEM */
				if (!w) { i = 0; break; }	/* ϊs\ȂALFN */
				if (_DF1S && w >= 0x100)	/* ꂪDBCȂ1޲Ăzu(SBCS`Ԑݒŏ펞U) */
					p[i++] = (TCHAR)(w >> 8);
#endif
				if (i >= fno->lfsize - 1) { i = 0; break; }	/* ɏՕȂALFN */
				p[i++] = (TCHAR)w;
			}
		}
		p[i] = 0;	/* \0ɂSFNI */
	}
#endif
}
#endif /* _FS_MINIMIZE <= 1 || _FS_RPATH >= 2 */

/*-----------------------------------------------------------------------*/
/* lv                                                              */
/*-----------------------------------------------------------------------*/
#if _USE_FIND && _FS_MINIMIZE <= 1
static
WCHAR get_achar (		/* 擾Ĉʒuwq1܂2is */
	const TCHAR** ptr	/* SBCS/DBCS/Unicodeɑ΂ʒuwqւ̈ʒuwq */
)
{
	WCHAR chr;

#if !_LFN_UNICODE
	chr = (BYTE)*(*ptr)++;					/* ޲Ď擾 */
	if (IsLower(chr)) chr -= 0x20;			/* 啶ASCII */
	if (IsDBCS1(chr) && IsDBCS2(**ptr))		/* KvƂȂADBC2޲Ă擾 */
		chr = chr << 8 | (BYTE)*(*ptr)++;
#ifdef _EXCVT
	if (chr >= 0x80) chr = ExCvt[chr - 0x80];	/* SBCSg̑啶 */
#endif
#else
	chr = ff_wtoupper(*(*ptr)++);			/* 擾đ啶 */
#endif
	return chr;
}

static
int pattern_matching (	/* 0:sv, 1:v */
	const TCHAR* pat,	/* vl */
	const TCHAR* nam,	/* ׂ */
	int skip,			/* \ߔ΂(?) */
	int inf				/*  (*w) */
)
{
	const TCHAR *pp, *np;
	WCHAR pc, nc;
	int nm, nx;

	while (skip--) {				/* \ߔ΂O */
		if (!get_achar(&nam)) return 0;	/* OȂAsv */
	}
	if (!*pat && inf) return 1;		/* (Z) */

	do {
		pp = pat; np = nam;			/* v̂߂̗lƖO̐擪 */
		for (;;) {
			if (*pp == '?' || *pp == '*') {	/* ܲ޶? */
				nm = nx = 0;
				do {				/* ܲ޶ޕ𕪐 */
					if (*pp++ == '?') nm++; else nx = 1;
				} while (*pp == '?' || *pp == '*');
				if (pattern_matching(pp, np, nm, nx)) return 1;	/* VK򌟍(lܲ޶މ򐔂܂ŌJԂ) */
				nc = *np; break;	/* sv */
			}
			pc = get_achar(&pp);	/* l擾 */
			nc = get_achar(&np);	/* O擾 */
			if (pc != nc) break;	/* sv? */
			if (!pc) return 1;		/* v? (̍Ōňv) */
		}
		get_achar(&nam);			/* nam++ */
	} while (inf && nc);			/* wȂAO̍Ō܂ōĎs */

	return 0;
}
#endif /* _USE_FIND && _FS_MINIMIZE <= 1 */

/*-----------------------------------------------------------------------*/
/* 擪Ă̎悵ިڸ،`őΏە̖O쐬                   */
/*-----------------------------------------------------------------------*/

static
FRESULT create_name (	/* FR_OK:, FR_INVALID_NAME:쐬s\ */
	DIR* dp,			/* ިڸؑΏەւ̈ʒuwq */
	const TCHAR** path	/* ߽̾Ăɑ΂ʒuwqւ̈ʒuwq */
)
{
#if _USE_LFN	/* LFN`Ԑݒ */
	BYTE b, cf;
	WCHAR w, *lfn;
	UINT i, ni, si, di;
	const TCHAR *p;

	/* UnicodeLFN쐬 */
	for (p = *path; *p == '/' || *p == '\\'; p++) ;	/* dq */
	lfn = dp->lfn;
	si = di = 0;
	for (;;) {
		w = p[si++];					/* 擾 */
		if (w < ' ' || w == '/' || w == '\\') break;	/* Ă̍ŌŒf */
		if (di >= _MAX_LFN)				/* 閼OO */
			return FR_INVALID_NAME;
#if !_LFN_UNICODE
		w &= 0xFF;
		if (IsDBCS1(w)) {				/* DBC̑1޲Ă(SBCS`ԐݒŏɋU) */
			b = (BYTE)p[si++];			/* 2޲Ď擾 */
			w = (w << 8) + b;			/* DBC쐬 */
			if (!IsDBCS2(b))
				return FR_INVALID_NAME;	/* AO */
		}
		w = ff_convert(w, 1);			/* ANSI/OEMUnicodeɕϊ */
		if (!w) return FR_INVALID_NAME;	/* O */
#endif
		if (w < 0x80 && chk_chr("\"*:<>\?|\x7F", w)) /* LFNɑ΂ĖO */
			return FR_INVALID_NAME;
		lfn[di++] = w;					/* Unicodei[ */
	}
	*path = &p[si];						/* Ăւ̈ʒuwqԂB */
	cf = (w < ' ') ? NS_LAST : 0;		/* ߽̍ŌȂAŏI ׸ނݒ */
#if _FS_RPATH
	if ((di == 1 && lfn[di - 1] == '.') ||
		(di == 2 && lfn[di - 1] == '.' && lfn[di - 2] == '.')) {	/* ̾Ă͏_? */
		lfn[di] = 0;
		for (i = 0; i < 11; i++)		/* SFNɑ΂ď_쐬 */
			dp->fn[i] = (i < di) ? '.' : ' ';
		dp->fn[i] = cf | NS_DOT;		/* ͏_ */
		return FR_OK;
	}
#endif
	while (di) {						/* ݂ȂA̋󔒂Ə_ */
		w = lfn[di - 1];
		if (w != ' ' && w != '.') break;
		di--;
	}
	if (!di) return FR_INVALID_NAME;	/* NULLO */
	lfn[di] = 0;						/* LFN쐬ς */

	/* ިڸ،`SFN쐬 */
	mem_set(dp->fn, ' ', 11);
	for (si = 0; lfn[si] == ' ' || lfn[si] == '.'; si++) ;	/* s̋󔒂Ə_ */
	if (si) cf |= NS_LOSS | NS_LFN;
	while (di && lfn[di - 1] != '.') di--;	/* gq(di<=si:gqȂ) */

	b = i = 0; ni = 8;
	for (;;) {
		w = lfn[si++];					/* LFN擾 */
		if (!w) break;					/* LFN̍ŌŒf */
		if (w == ' ' || (w == '.' && si != di)) {	/* 󔒂Ə_ */
			cf |= NS_LOSS | NS_LFN; continue;
		}

		if (i >= ni || si == di) {		/* gq܂SFN̍Ō */
			if (ni == 11) {				/* gq */
				cf |= NS_LOSS | NS_LFN; break;
			}
			if (si != di) cf |= NS_LOSS | NS_LFN;	/* 8.3`ȊO */
			if (si > di) break;			/* gqȂ */
			si = di; i = 8; ni = 11;	/* gq̈ɓ˓ */
			b <<= 2; continue;
		}

		if (w >= 0x80) {				/* ASCII */
#ifdef _EXCVT
			w = ff_convert(w, 0);		/* UnicodeOEM */
			if (w) w = ExCvt[w - 0x80];	/* g㑤(SBCS)ɕϊ */
#else
			w = ff_convert(ff_wtoupper(w), 0);	/* 㑤ϊꂽUnicodeOEM */
#endif
			cf |= NS_LFN;				/* LFN쐬 */
		}

		if (_DF1S && w >= 0x100) {		/* DBC? (SBCS`ԐݒȂAɋU) */
			if (i >= ni - 1) {
				cf |= NS_LOSS | NS_LFN; i = ni; continue;
			}
			dp->fn[i++] = (BYTE)(w >> 8);
		} else {						/* SBC */
			if (!w || chk_chr("+,;=[]", w)) {	/* SFNpɖu */
				w = '_'; cf |= NS_LOSS | NS_LFN;/* stϊ */
			} else {
				if (IsUpper(w)) {		/* ASCII啶 */
					b |= 2;
				} else {
					if (IsLower(w)) {	/* ASCII */
						b |= 1; w -= 0x20;
					}
				}
			}
		}
		dp->fn[i++] = (BYTE)w;
	}

	if (dp->fn[0] == DDEM) dp->fn[0] = RDDEM;	/* 擪DDEMƏՓ˂ꍇARDDEMŒu */

	if (ni == 8) b <<= 2;
	if ((b & 0x0C) == 0x0C || (b & 0x03) == 0x03)	/* /L鎞LFN쐬 */
		cf |= NS_LFN;
	if (!(cf & NS_LFN)) {						/* LFNgȂ8.3`̎NT׸ނ */
		if ((b & 0x03) == 0x01) cf |= NS_EXT;	/* NT׸(gq͏̂) */
		if ((b & 0x0C) == 0x04) cf |= NS_BODY;	/* NT׸(̧ٖ͏̂) */
	}

	dp->fn[NSFLAG] = cf;	/* SFN쐬ς */

	return FR_OK;

#else	/* LFN`Ԑݒ */
	BYTE b, c, d, *sfn;
	UINT ni, si, i;
	const char *p;

	/* ިڸ،`̧ٖ쐬 */
	for (p = *path; *p == '/' || *p == '\\'; p++) ;	/* dq΂B */
	sfn = dp->fn;
	mem_set(sfn, ' ', 11);
	si = i = b = 0; ni = 8;
#if _FS_RPATH
	if (p[si] == '.') { /* ͏_? */
		for (;;) {
			c = (BYTE)p[si++];
			if (c != '.' || si >= 3) break;
			sfn[i++] = c;
		}
		if (c != '/' && c != '\\' && c > ' ') return FR_INVALID_NAME;
		*path = &p[si];									/* Ăւ̈ʒuwqԂB */
		sfn[NSFLAG] = (c <= ' ') ? NS_LAST | NS_DOT : NS_DOT;	/* ߽̍ŌȂAŏI ׸ނݒ */
		return FR_OK;
	}
#endif
	for (;;) {
		c = (BYTE)p[si++];
		if (c <= ' ' || c == '/' || c == '\\') break;	/* Ă̍ŌŒf */
		if (c == '.' || i >= ni) {
			if (ni != 8 || c != '.') return FR_INVALID_NAME;
			i = 8; ni = 11;
			b <<= 2; continue;
		}
		if (c >= 0x80) {				/* g? */
			b |= 3;						/* NT׸ނ */
#ifdef _EXCVT
			c = ExCvt[c - 0x80];		/* 㑤g(SBCS`Ԑݒ) */
#else
#if !_DF1S
			return FR_INVALID_NAME;		/* gO(ASCII`Ԑݒ) */
#endif
#endif
		}
		if (IsDBCS1(c)) {				/* ꂪDBC̑1޲Ă(SBCS`ԐݒŏɋU) */
			d = (BYTE)p[si++];			/* 2޲Ď擾 */
			if (!IsDBCS2(d) || i >= ni - 1)	/* DBCO */
				return FR_INVALID_NAME;
			sfn[i++] = c;
			sfn[i++] = d;
		} else {						/* SBC */
			if (chk_chr("\"*+,:;<=>\?[]|\x7F", c))	/* SFNɑ΂ĖO */
				return FR_INVALID_NAME;
			if (IsUpper(c)) {			/* ASCII啶? */
				b |= 2;
			} else {
				if (IsLower(c)) {		/* ASCII? */
					b |= 1; c -= 0x20;
				}
			}
			sfn[i++] = c;
		}
	}
	*path = &p[si];						/* Ăւ̈ʒuwqԂB */
	c = (c <= ' ') ? NS_LAST : 0;		/* ߽̍ŌȂAŏI ׸ސݒ */

	if (!i) return FR_INVALID_NAME;		/* NULL񏜊O */
	if (sfn[0] == DDEM) sfn[0] = RDDEM;	/* 擪DDEMƏՓ˂鎞RDDEMŒu */

	if (ni == 8) b <<= 2;
	if ((b & 0x03) == 0x01) c |= NS_EXT;	/* NT׸(O̊gq̂) */
	if ((b & 0x0C) == 0x04) c |= NS_BODY;	/* NT׸(O̖{̂̂) */

	sfn[NSFLAG] = c;		/* NT׸ފi[A̧ٖ쐬ς */

	return FR_OK;
#endif
}

/*-----------------------------------------------------------------------*/
/* ̧ ߽ǋy                                                        */
/*-----------------------------------------------------------------------*/

static
FRESULT follow_path (	/* FR_OK(0):, !=0:ُ필 */
	DIR* dp,			/* ŏIިڸ؂ԂđΏە邽߂ިڸؑΏە */
	const TCHAR* path	/* ̧ق܂ިڸ؂{߂̊S߽ */
)
{
	FRESULT res;
	BYTE *dir, ns;

#if _FS_RPATH
	if (*path == '/' || *path == '\\') {	/* 擪ɕqL */
		path++;	dp->sclust = 0;				/* č{ިڸ؂Jn */
	} else {								/* 擪qȂ */
		dp->sclust = dp->fs->cdir;			/* ݂ިڸ؂Jn */
	}
#else
	if (*path == '/' || *path == '\\')		/* ݂ȂA擪̕q */
		path++;
	dp->sclust = 0;							/* ɍ{ިڸ؂Jn */
#endif

	if ((UINT)*path < ' ') {				/* NULL߽͌ިڸ؂ꎩg */
		res = dir_sdi(dp, 0);
		dp->dir = 0;
	} else {								/* ߽ǋy */
		for (;;) {
			res = create_name(dp, &path);	/* ߽̾Ė擾 */
			if (res != FR_OK) break;
			res = dir_find(dp);				/* ĖΏە{B */
			ns = dp->fn[NSFLAG];
			if (res != FR_OK) {				/* Ώەs */
				if (res == FR_NO_FILE) {	/* ΏەȂB */
					if (_FS_RPATH && (ns & NS_DOT)) {	/* _݂Ȃꍇ */
						dp->sclust = 0; dp->dir = 0;	/* ͍{ިڸ؂łɗ܂B */
						if (!(ns & NS_LAST)) continue;	/* ŏIĂłȂ΁Aǋyp */
						res = FR_OK;					/* {ިڸ؂ŏIA֐͊ */
					} else {							/* ΏەȂB */
						if (!(ns & NS_LAST)) res = FR_NO_PATH;	/* ŏIĂłȂΈُ필 */
					}
				}
				break;
			}
			if (ns & NS_LAST) break;			/* ŏIĈvA֐͊ */
			dir = dp->dir;						/* ިڸ؂ǋy */
			if (!(dir[DIR_Attr] & AM_DIR)) {	/* ͕ިڸ؂ł͂ȂAǋys\ */
				res = FR_NO_PATH; break;
			}
			dp->sclust = ld_clust(dp->fs, dir);
		}
	}

	return res;
}

/*-----------------------------------------------------------------------*/
/* ߽_ײޔԍ擾                                         */
/*-----------------------------------------------------------------------*/

static
int get_ldnumber (		/* _ײޔԍԂB(-1:ײ) */
	const TCHAR** path	/* ߽ɑ΂ʒuwqւ̈ʒuwq */
)
{
	const TCHAR *tp, *tt;
	UINT i;
	int vol = -1;
#if _STR_VOLUME_ID		/* ײID{B */
	static const char* const str[] = {_VOLUME_STRS};
	const char *sp;
	char c;
	TCHAR tc;
#endif


	if (*path) {	/* ʒuwqNULLł͂΁A */
		for (tt = *path; (UINT)*tt >= (_USE_LFN ? ' ' : '!') && *tt != ':'; tt++) ;	/* ߽':' */
		if (*tt == ':') {	/* ߽':'݂ꍇA */
			tp = *path;
			i = *tp++ - '0'; 
			if (i < 10 && tp == tt) {	/* ײID邩? */
				if (i < _VOLUMES) {	/* ײIDꍇAl擾Ă */
					vol = (int)i;
					*path = ++tt;
				}
			}
#if _STR_VOLUME_ID
			 else {	/* ײޔԍłȂAײID{B */
				i = 0; tt++;
				do {
					sp = str[i]; tp = *path;
					do {	/* ײID߽r */
						c = *sp++; tc = *tp++;
						if (IsLower(tc)) tc -= 0x20;
					} while (c && (TCHAR)c == tc);
				} while ((c || tp != tt) && ++i < _VOLUMES);	/* lv܂ŊeIDJԂB */
				if (i < _VOLUMES) {	/* ײIDꍇAl擾Ă */
					vol = (int)i;
					*path = tt;
				}
			}
#endif
			return vol;
		}
#if _FS_RPATH && _VOLUMES >= 2
		vol = CurrVol;	/* ݂ײ */
#else
		vol = 0;		/* ײ0 */
#endif
	}
	return vol;
}

/*-----------------------------------------------------------------------*/
/* ݒ肵ĂꂪFATް                                   */
/*-----------------------------------------------------------------------*/

static
BYTE check_fs (	/* 0:LFAT-BS, 1:LBSł邪FAT, 2:BS, 3:ިُ */
	FATFS* fs,	/* ̧ ёΏە */
	DWORD sect	/* FATް ںނۂ𒲂ׂ龸ԍ(LBA) */
)
{
	fs->wflag = 0; fs->winsect = 0xFFFFFFFF;	/*  */
	if (move_window(fs, sect) != FR_OK)			/* ް ںސݒ */
		return 3;

	if (LD_WORD(&fs->win[BS_55AA]) != 0xAA55)	/* ް ںގ[(Ⴆeʂ512łɕψ510Ŕzu) */
		return 2;

	if ((LD_DWORD(&fs->win[BS_FilSysType]) & 0xFFFFFF) == 0x544146)		/* "FAT"񌟍 */
		return 0;
	if ((LD_DWORD(&fs->win[BS_FilSysType32]) & 0xFFFFFF) == 0x544146)	/* "FAT"񌟍 */
		return 0;

	return 1;
}

/*-----------------------------------------------------------------------*/
/* _ײނ{حтꂿ邩                          */
/*-----------------------------------------------------------------------*/

static
FRESULT find_volume (	/* FR_OK(0):, !=0:炩ُ̈픭 */
	FATFS** rfs,		/* ̧ ёΏە{߂̈ʒuwqւ̈ʒuwq */
	const TCHAR** path,	/* ߽(ײޔԍ)̂߂̈ʒuwqւ̈ʒuwq */
	BYTE wmode			/* !=0:ݱ̂߂̏ݕی쌟 */
)
{
	BYTE fmt, *pt;
	int vol;
	DSTATUS stat;
	DWORD bsect, fasize, tsect, sysect, nclst, szbfat, br[4];
	WORD nrsv;
	FATFS *fs;
	UINT i;

	/* ߽_ײޔԍ擾 */
	*rfs = 0;
	vol = get_ldnumber(path);
	if (vol < 0) return FR_INVALID_DRIVE;

	/* ̧ ёΏەLȔۂ𒲍 */
	fs = FatFs[vol];					/* ̧ ёΏەւ̈ʒuwq擾 */
	if (!fs) return FR_NOT_ENABLED;		/* ̧ ёΏەp\? */

	ENTER_FF(fs);						/* حт{ */
	*rfs = fs;							/* ̧ ёΏەւ̈ʒuwqԂB */

	if (fs->fs_type) {					/* حтĂꍇA */
		stat = disk_status(fs->drv);
		if (!(stat & STA_NOINIT)) {		/* ĕײނ͏ێ */
			if (!_FS_READONLY && wmode && (stat & STA_PROTECT))	/* KvƂꍇɏݕی쌟 */
				return FR_WRITE_PROTECTED;
			return FR_OK;				/* ̧ ёΏە͗L */
		}
	}

	/* ̧ ёΏە͖ */
	/* ȉ̺ނحё݂܂B(BPB𕪐̧͂ ёΏە) */

	fs->fs_type = 0;					/* ̧ ёΏە쐬 */
	fs->drv = LD2PD(vol);				/* _ײނƕײނ */
	stat = disk_initialize(fs->drv);	/* ײޏ */
	if (stat & STA_NOINIT)				/*  */
		return FR_NOT_READY;			/* }̂Ȃ܂ʰ޳ُ̂߂ɏs */
	if (!_FS_READONLY && wmode && (stat & STA_PROTECT))	/* KvƂȂAިݕی쌟 */
		return FR_WRITE_PROTECTED;
#if _MAX_SS != _MIN_SS						/* eʎ擾(eʌ`Ԑݒ̂) */
	if (disk_ioctl(fs->drv, GET_SECTOR_SIZE, &SS(fs)) != RES_OK
		|| SS(fs) < _MIN_SS || SS(fs) > _MAX_SS) return FR_DISK_ERR;
#endif
	/* ײޏFAT߰è݂{BW߰è݁AFDISKASFD̂ݎx */
	bsect = 0;
	fmt = check_fs(fs, bsect);					/* 0ݒ肵ĂꂪSFDƂĂFATް  */
	if (fmt == 1 || (!fmt && (LD2PT(vol)))) {	/* FATް łȂA܂͋ꂽ߰èݔԍ */
		for (i = 0; i < 4; i++) {			/* ߰èݕψʎ擾 */
			pt = fs->win + MBR_Table + i * SZ_PTE;
			br[i] = pt[4] ? LD_DWORD(&pt[8]) : 0;
		}
		i = LD2PT(vol);						/* ߰èݔԍ: 0:, 1-4: */
		if (i) i--;
		do {								/* FATحт{B */
			bsect = br[i];
			fmt = bsect ? check_fs(fs, bsect) : 2;	/* ߰èݒ */
		} while (!LD2PT(vol) && fmt && ++i < 4);
	}
	if (fmt == 3) return FR_DISK_ERR;		/* ިo͑wňُ픭 */
	if (fmt) return FR_NO_FILESYSTEM;		/* FATحє */

	/* FATحєB̧ ёΏە */

	if (LD_WORD(fs->win + BPB_BytsPerSec) != SS(fs))	/* (BPB_BytsPerSec͕eʂƓȂ΂Ȃ܂B) */
		return FR_NO_FILESYSTEM;

	fasize = LD_WORD(fs->win + BPB_FATSz16);			/* FAT̾ */
	if (!fasize) fasize = LD_DWORD(fs->win + BPB_FATSz32);
	fs->fsize = fasize;

	fs->n_fats = fs->win[BPB_NumFATs];					/* FAT */
	if (fs->n_fats != 1 && fs->n_fats != 2)				/* (1܂2łȂ΂Ȃ܂B) */
		return FR_NO_FILESYSTEM;
	fasize *= fs->n_fats;								/* FAT̈p */

	fs->csize = fs->win[BPB_SecPerClus];				/* ׽̾ */
	if (!fs->csize || (fs->csize & (fs->csize - 1)))	/* (2̗ݏłȂ΂Ȃ܂B) */
		return FR_NO_FILESYSTEM;

	fs->n_rootdir = LD_WORD(fs->win + BPB_RootEntCnt);	/* {ިڸؓ */
	if (fs->n_rootdir % (SS(fs) / SZ_DIRE))				/* (Ő񂵂ĂȂ΂Ȃ܂B) */
		return FR_NO_FILESYSTEM;

	tsect = LD_WORD(fs->win + BPB_TotSec16);			/* حт̾ */
	if (!tsect) tsect = LD_DWORD(fs->win + BPB_TotSec32);

	nrsv = LD_WORD(fs->win + BPB_RsvdSecCnt);			/* \ */
	if (!nrsv) return FR_NO_FILESYSTEM;					/* (0łȂ΂Ȃ܂B) */

	/* FAT⏕` */
	sysect = nrsv + fasize + fs->n_rootdir / (SS(fs) / SZ_DIRE);	/* RSV+FAT+DIR */
	if (tsect < sysect) return FR_NO_FILESYSTEM;		/* (حїe) */
	nclst = (tsect - sysect) / fs->csize;				/* ׽ */
	if (!nclst) return FR_NO_FILESYSTEM;				/* (حїe) */
	fmt = FS_FAT12;
	if (nclst >= MIN_FAT16) fmt = FS_FAT16;
	if (nclst >= MIN_FAT32) fmt = FS_FAT32;

	/* EƐ */
	fs->n_fatent = nclst + 2;							/* FAT */
	fs->volbase = bsect;								/* حъJn */
	fs->fatbase = bsect + nrsv; 						/* FATJn */
	fs->database = bsect + sysect;						/* ްJn */
	if (fmt == FS_FAT32) {
		if (fs->n_rootdir) return FR_NO_FILESYSTEM;		/* (BPB_RootEntCnt0łȂ΂Ȃ܂B) */
		fs->dirbase = LD_DWORD(fs->win + BPB_RootClus);	/* {ިڸ؊Jn׽ */
		szbfat = fs->n_fatent * 4;						/* (߂FATe) */
	} else {
		if (!fs->n_rootdir)	return FR_NO_FILESYSTEM;	/* (BPB_RootEntCnt0łȂ΂Ȃ܂B) */
		fs->dirbase = fs->fatbase + fasize;				/* {ިڸ؊Jn */
		szbfat = (fmt == FS_FAT16) ?					/* (߂FATe) */
			fs->n_fatent * 2 : fs->n_fatent * 3 / 2 + (fs->n_fatent & 1);
	}
	if (fs->fsize < (szbfat + (SS(fs) - 1)) / SS(fs))	/* (BPB_FATSz͋߂eʂȂĂ͂Ȃ܂B) */
		return FR_NO_FILESYSTEM;

#if !_FS_READONLY
	/* ׽蓖ď񏉊 */
	fs->last_clust = fs->free_clust = 0xFFFFFFFF;

	/* p\ȂA̧ я(FSINFO)擾 */
	fs->fsi_flag = 0x80;
#if (_FS_NOFSINFO & 3) != 3
	if (fmt == FS_FAT32				/* FAT32BPB_FSInfo1̏ꍇɂFSINFO */
		&& LD_WORD(fs->win + BPB_FSInfo) == 1
		&& move_window(fs, bsect + 1) == FR_OK)
	{
		fs->fsi_flag = 0;
		if (LD_WORD(fs->win + BS_55AA) == 0xAA55	/* p\ȂAFSINFOްݒ */
			&& LD_DWORD(fs->win + FSI_LeadSig) == 0x41615252
			&& LD_DWORD(fs->win + FSI_StrucSig) == 0x61417272)
		{
#if (_FS_NOFSINFO & 1) == 0
			fs->free_clust = LD_DWORD(fs->win + FSI_Free_Count);
#endif
#if (_FS_NOFSINFO & 2) == 0
			fs->last_clust = LD_DWORD(fs->win + FSI_Nxt_Free);
#endif
		}
	}
#endif
#endif
	fs->fs_type = fmt;	/* FAT⏕` */
	fs->id = ++Fsid;	/* ̧ ёID */
#if _FS_RPATH
	fs->cdir = 0;		/* ݂ިڸ؂{ɐݒ */
#endif
#if _FS_LOCK			/* َ̧{̫ */
	clear_lock(fs);
#endif

	return FR_OK;
}

/*-----------------------------------------------------------------------*/
/* ̧/ިڸؑΏەLۂ                                    */
/*-----------------------------------------------------------------------*/

static
FRESULT validate (	/* FR_OK(0):Ώە͗L, !=0: */
	void* obj		/* L𒲂ׂ̧/ިڸؑΏەւ̈ʒuwq */
)
{
	FIL *fil = (FIL*)obj;	/* ̧/ިڸ؍\̓.fs.id̕ψʂƉ */


	if (!fil || !fil->fs || !fil->fs->fs_type || fil->fs->id != fil->id || (disk_status(fil->fs->drv) & STA_NOINIT))
		return FR_INVALID_OBJECT;

	ENTER_FF(fil->fs);		/* ̧ ю{ */

	return FR_OK;
}


/*--------------------------------------------------------------------------

   I֐

---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* _ײގt/O                                           */
/*-----------------------------------------------------------------------*/

FRESULT f_mount (
	FATFS* fs,			/* ̧ ёΏەւ̈ʒuwq(NULL:O)*/
	const TCHAR* path,	/* t/Oׂ_ײޔԍ */
	BYTE opt			/* 0:tȂ(xt), 1:t */
)
{
	FATFS *cfs;
	int vol;
	FRESULT res;
	const TCHAR *rp = path;


	vol = get_ldnumber(&rp);
	if (vol < 0) return FR_INVALID_DRIVE;
	cfs = FatFs[vol];					/* ̧ ёΏەւ̈ʒuwq */

	if (cfs) {
#if _FS_LOCK
		clear_lock(cfs);
#endif
#if _FS_REENTRANT						/* ݂حт̓Ώەj */
		if (!ff_del_syncobj(cfs->sobj)) return FR_INT_ERR;
#endif
		cfs->fs_type = 0;				/* ̧ ёΏە */
	}

	if (fs) {
		fs->fs_type = 0;				/* V̧ ёΏە */
#if _FS_REENTRANT						/* حт̓Ώە쐬 */
		if (!ff_cre_syncobj((BYTE)vol, &fs->sobj)) return FR_INT_ERR;
#endif
	}
	FatFs[vol] = fs;					/* V̧ ёΏەo^ */

	if (!fs || opt != 1) return FR_OK;	/* tȂA͌Ŏt */

	res = find_volume(&fs, &path, 0);	/* حт */
	LEAVE_FF(fs, res);
}

/*-----------------------------------------------------------------------*/
/* ̧قJ܂͍쐬                                                  */
/*-----------------------------------------------------------------------*/

FRESULT f_open (
	FIL* fp,			/* ّ̧Ώەւ̈ʒuwq */
	const TCHAR* path,	/* ̧ٖւ̈ʒuwq */
	BYTE mode			/* ʂ̧قJʂ׸ */
)
{
	FRESULT res;
	DIR dj;
	BYTE *dir;
	DEFINE_NAMEBUF;
#if !_FS_READONLY
	DWORD dw, cl;
#endif


	if (!fp) return FR_INVALID_OBJECT;
	fp->fs = 0;			/* ّ̧Ώە */

	/* _ײޔԍ擾 */
#if !_FS_READONLY
	mode &= FA_READ | FA_WRITE | FA_CREATE_ALWAYS | FA_OPEN_ALWAYS | FA_CREATE_NEW;
	res = find_volume(&dj.fs, &path, (BYTE)(mode & ~FA_READ));
#else
	mode &= FA_READ;
	res = find_volume(&dj.fs, &path, 0);
#endif
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);	/* ̧ ߽ǋy */
		dir = dj.dir;
#if !_FS_READONLY	/* R/W`Ԑݒ */
		if (res == FR_OK) {
			if (!dir)	/* ިڸ؂ꎩg */
				res = FR_INVALID_NAME;
#if _FS_LOCK
			else
				res = chk_lock(&dj, (mode & ~FA_READ) ? 1 : 0);
#endif
		}
		/* ̧ق쐬܂͊J */
		if (mode & (FA_CREATE_ALWAYS | FA_OPEN_ALWAYS | FA_CREATE_NEW)) {
			if (res != FR_OK) {					/* ̧قȂŁA쐬 */
				if (res == FR_NO_FILE)			/* J̧قȂAV쐬 */
#if _FS_LOCK
					res = enq_lock() ? dir_register(&dj) : FR_TOO_MANY_OPEN_FILES;
#else
					res = dir_register(&dj);
#endif
				mode |= FA_CREATE_ALWAYS;		/* ̧ق쐬I */
				dir = dj.dir;					/* V */
			}
			else {								/* ꂩ̑Ώەɑ */
				if (dir[DIR_Attr] & (AM_RDO | AM_DIR)) {	/* ㏑s\(R/O܂DIR) */
					res = FR_DENIED;
				} else {
					if (mode & FA_CREATE_NEW)	/* VĶقƂč쐬s\ */
						res = FR_EXIST;
				}
			}
			if (res == FR_OK && (mode & FA_CREATE_ALWAYS)) {	/* ㏑ȂA؂l */
				dw = GET_FATTIME();
				ST_DWORD(dir + DIR_CrtTime, dw);/* 쐬ݒ */
				ST_DWORD(dir + DIR_WrtTime, dw);/* ύXݒ */
				dir[DIR_Attr] = 0;				/* ؾ */
				ST_DWORD(dir + DIR_FileSize, 0);/* ̧ٗeؾ */
				cl = ld_clust(dj.fs, dir);		/* ׽A擾 */
				st_clust(dir, 0);				/* ׽ ؾ */
				dj.fs->wflag = 1;
				if (cl) {						/* ȂA׽A */
					dw = dj.fs->winsect;
					res = remove_chain(dj.fs, cl);
					if (res == FR_OK) {
						dj.fs->last_clust = cl - 1;	/* ׽󌊂Ďgp */
						res = move_window(dj.fs, dw);
					}
				}
			}
		}
		else {	/* ̧قJ */
			if (res == FR_OK) {					/* ȂAp */
				if (dir[DIR_Attr] & AM_DIR) {	/* ިڸ */
					res = FR_NO_FILE;
				} else {
					if ((mode & FA_WRITE) && (dir[DIR_Attr] & AM_RDO)) /* R/Oᔽ */
						res = FR_DENIED;
				}
			}
		}
		if (res == FR_OK) {
			if (mode & FA_CREATE_ALWAYS)		/* 쐬܂͏㏑ȂA̧ٕύX׸ސݒ */
				mode |= FA__WRITTEN;
			fp->dir_sect = dj.fs->winsect;		/* ިڸؓւ̈ʒuwq */
			fp->dir_ptr = dir;
#if _FS_LOCK
			fp->lockid = inc_lock(&dj, (mode & ~FA_READ) ? 1 : 0);
			if (!fp->lockid) res = FR_INT_ERR;
#endif
		}

#else				/* R/O`Ԑݒ */
		if (res == FR_OK) {					/* ȂAp */
			dir = dj.dir;
			if (!dir) {						/* ݂ިڸ؂ꂢg */
				res = FR_INVALID_NAME;
			} else {
				if (dir[DIR_Attr] & AM_DIR)	/* ިڸ */
					res = FR_NO_FILE;
			}
		}
#endif
		FREE_BUF();

		if (res == FR_OK) {
			fp->flag = mode;					/* ̧  */
			fp->err = 0;						/* ُ׸މ */
			fp->sclust = ld_clust(dj.fs, dir);	/* ̧يJn׽ */
			fp->fsize = LD_DWORD(dir + DIR_FileSize);	/* ̧ٗe */
			fp->fptr = 0;						/* ̧وʒuwq */
			fp->dsect = 0;
#if _USE_FASTSEEK
			fp->cltbl = 0;						/* ʏ팟 */
#endif
			fp->fs = dj.fs;	 					/* ĻّΏە */
			fp->id = fp->fs->id;
		}
	}

	LEAVE_FF(dj.fs, res);
}

/*-----------------------------------------------------------------------*/
/* ̧ٓǂݍ                                                          */
/*-----------------------------------------------------------------------*/

FRESULT f_read (
	FIL* fp, 		/* ّ̧Ώەւ̈ʒuwq */
	void* buff,		/* ްɏՕւ̈ʒuwq */
	UINT btr,		/* ǂݍ޲Đ */
	UINT* br		/* ǂݍ޲Đւ̈ʒuwq */
)
{
	FRESULT res;
	DWORD clst, sect, remain;
	UINT rcnt, cc;
	BYTE csect, *rbuff = (BYTE*)buff;


	*br = 0;	/* ǂݍ޲Čv */

	res = validate(fp);							/* L */
	if (res != FR_OK) LEAVE_FF(fp->fs, res);
	if (fp->err)								/* ُ팟 */
		LEAVE_FF(fp->fs, (FRESULT)fp->err);
	if (!(fp->flag & FA_READ)) 					/* ʌ */
		LEAVE_FF(fp->fs, FR_DENIED);
	remain = fp->fsize - fp->fptr;
	if (btr > remain) btr = (UINT)remain;		/* c޲Ăɂbtr؂l */

	for ( ;  btr;								/* Sްǂݍ݂܂ŌJԂ */
		rbuff += rcnt, fp->fptr += rcnt, *br += rcnt, btr -= rcnt) {
		if ((fp->fptr % SS(fp->fs)) == 0) {		/* E? */
			csect = (BYTE)(fp->fptr / SS(fp->fs) & (fp->fs->csize - 1));	/* ׽̾ψ */
			if (!csect) {						/* ׽E? */
				if (fp->fptr == 0) {			/* ِ̧擪? */
					clst = fp->sclust;			/* _瑱 */
				} else {						/* ̧ق̒Ԃ܂͍Ō */
#if _USE_FASTSEEK
					if (fp->cltbl)
						clst = clmt_clust(fp, fp->fptr);	/* CLMT׽ԍ擾 */
					else
#endif
						clst = get_fat(fp->fs, fp->clust);	/* FATł̸׽Aɏ] */
				}
				if (clst < 2) ABORT(fp->fs, FR_INT_ERR);
				if (clst == 0xFFFFFFFF) ABORT(fp->fs, FR_DISK_ERR);
				fp->clust = clst;				/* ̸݂׽XV */
			}
			sect = clust2sect(fp->fs, fp->clust);	/* ݂̾擾 */
			if (!sect) ABORT(fp->fs, FR_INT_ERR);
			sect += csect;
			cc = btr / SS(fp->fs);				/* c޲āeʂȂA */
			if (cc) {							/* őA ިڸ؂ǂ */
				if (csect + cc > fp->fs->csize)	/* ׽EŐ؂ */
					cc = fp->fs->csize - csect;
				if (disk_read(fp->fs->drv, rbuff, sect, cc) != RES_OK)
					ABORT(fp->fs, FR_DISK_ERR);
#if !_FS_READONLY && _FS_MINIMIZE <= 2			/* ύX܂ޏꍇA ްœǂ񂾾1u */
#if _FS_TINY
				if (fp->fs->wflag && fp->fs->winsect - sect < cc)
					mem_cpy(rbuff + ((fp->fs->winsect - sect) * SS(fp->fs)), fp->fs->win, SS(fp->fs));
#else
				if ((fp->flag & FA__DIRTY) && fp->dsect - sect < cc)
					mem_cpy(rbuff + ((fp->dsect - sect) * SS(fp->fs)), fp->buf, SS(fp->fs));
#endif
#endif
				rcnt = SS(fp->fs) * cc;			/* ]޲Đ */
				continue;
			}
#if !_FS_TINY
			if (fp->dsect != sect) {			/* ɂȂ΁Aް ݒ */
#if !_FS_READONLY
				if (fp->flag & FA__DIRTY) {		/* ύX̷߂ */
					if (disk_write(fp->fs->drv, fp->buf, fp->dsect, 1) != RES_OK)
						ABORT(fp->fs, FR_DISK_ERR);
					fp->flag &= ~FA__DIRTY;
				}
#endif
				if (disk_read(fp->fs->drv, fp->buf, sect, 1) != RES_OK)	/*  𖞂 */
					ABORT(fp->fs, FR_DISK_ERR);
			}
#endif
			fp->dsect = sect;
		}
		rcnt = SS(fp->fs) - ((UINT)fp->fptr % SS(fp->fs));	/* ɏՕ畔 ް擾 */
		if (rcnt > btr) rcnt = btr;
#if _FS_TINY
		if (move_window(fp->fs, fp->dsect) != FR_OK)		/* ړ */
			ABORT(fp->fs, FR_DISK_ERR);
		mem_cpy(rbuff, &fp->fs->win[fp->fptr % SS(fp->fs)], rcnt);	/* ̎ */
#else
		mem_cpy(rbuff, &fp->buf[fp->fptr % SS(fp->fs)], rcnt);	/* ̎ */
#endif
	}

	LEAVE_FF(fp->fs, FR_OK);
}

#if !_FS_READONLY
/*-----------------------------------------------------------------------*/
/* ُ̧                                                          */
/*-----------------------------------------------------------------------*/

FRESULT f_write (
	FIL* fp,			/* ّ̧Ώەւ̈ʒuwq */
	const void *buff,	/* ׂްւ̈ʒuwq */
	UINT btw,			/* ޲Đ */
	UINT* bw			/* ꂽ޲Đւ̈ʒuwq */
)
{
	FRESULT res;
	DWORD clst, sect;
	UINT wcnt, cc;
	const BYTE *wbuff = (const BYTE*)buff;
	BYTE csect;


	*bw = 0;	/* ޲Čv */

	res = validate(fp);						/* L */
	if (res != FR_OK) LEAVE_FF(fp->fs, res);
	if (fp->err)							/* ُ팟 */
		LEAVE_FF(fp->fs, (FRESULT)fp->err);
	if (!(fp->flag & FA_WRITE))				/* ʒ */
		LEAVE_FF(fp->fs, FR_DENIED);
	if (fp->fptr + btw < fp->fptr) btw = 0;	/* ̧ٗeʂ4GBɓBs */

	for ( ;  btw;							/* Sް݂܂ŌJԂ */
		wbuff += wcnt, fp->fptr += wcnt, *bw += wcnt, btw -= wcnt) {
		if ((fp->fptr % SS(fp->fs)) == 0) {	/* E? */
			csect = (BYTE)(fp->fptr / SS(fp->fs) & (fp->fs->csize - 1));	/* ׽̾ψ */
			if (!csect) {					/* ׽E? */
				if (fp->fptr == 0) {		/* ِ̧擪? */
					clst = fp->sclust;		/* _瑱 */
					if (clst == 0)			/* ׽S蓖ĂĂȂꍇA */
						clst = create_chain(fp->fs, 0);	/* VK׽A쐬 */
				} else {					/* ̧ق̒Ԃ܂͍Ō */
#if _USE_FASTSEEK
					if (fp->cltbl)
						clst = clmt_clust(fp, fp->fptr);	/* CLMT׽ԍ擾 */
					else
#endif
						clst = create_chain(fp->fs, fp->clust);	/* FATł̸׽Aɏ]A܂͐L */
				}
				if (clst == 0) break;		/* V׽蓖ĕs\(ިt) */
				if (clst == 1) ABORT(fp->fs, FR_INT_ERR);
				if (clst == 0xFFFFFFFF) ABORT(fp->fs, FR_DISK_ERR);
				fp->clust = clst;			/* ̸݂׽XV */
				if (fp->sclust == 0) fp->sclust = clst;	/* ŏ݂̏ȂAJn׽ݒ */
			}
#if _FS_TINY
			if (fp->fs->winsect == fp->dsect && sync_window(fp->fs))	/*  ߂ */
				ABORT(fp->fs, FR_DISK_ERR);
#else
			if (fp->flag & FA__DIRTY) {		/*  ߂ */
				if (disk_write(fp->fs->drv, fp->buf, fp->dsect, 1) != RES_OK)
					ABORT(fp->fs, FR_DISK_ERR);
				fp->flag &= ~FA__DIRTY;
			}
#endif
			sect = clust2sect(fp->fs, fp->clust);	/* ݂̾擾 */
			if (!sect) ABORT(fp->fs, FR_INT_ERR);
			sect += csect;
			cc = btw / SS(fp->fs);			/* c޲āeʂȂA */
			if (cc) {						/* őA ިڸ؂ */
				if (csect + cc > fp->fs->csize)	/* ׽EŐ؂ */
					cc = fp->fs->csize - csect;
				if (disk_write(fp->fs->drv, wbuff, sect, cc) != RES_OK)
					ABORT(fp->fs, FR_DISK_ERR);
#if _FS_MINIMIZE <= 2
#if _FS_TINY
				if (fp->fs->winsect - sect < cc) {	/* ڏ݂ɂĖꂽꍇA ߂ĖB */
					mem_cpy(fp->fs->win, wbuff + ((fp->fs->winsect - sect) * SS(fp->fs)), SS(fp->fs));
					fp->fs->wflag = 0;
				}
#else
				if (fp->dsect - sect < cc) { /* ڏ݂ɂĖꂽꍇA ߂ĖB */
					mem_cpy(fp->buf, wbuff + ((fp->dsect - sect) * SS(fp->fs)), SS(fp->fs));
					fp->flag &= ~FA__DIRTY;
				}
#endif
#endif
				wcnt = SS(fp->fs) * cc;		/* ]޲Đ */
				continue;
			}
#if _FS_TINY
			if (fp->fptr >= fp->fsize) {	/* т[ŖӖȷ[ */
				if (sync_window(fp->fs)) ABORT(fp->fs, FR_DISK_ERR);
				fp->fs->winsect = sect;
			}
#else
			if (fp->dsect != sect) {		/* ̧ ްž [ */
				if (fp->fptr < fp->fsize &&
					disk_read(fp->fs->drv, fp->buf, sect, 1) != RES_OK)
						ABORT(fp->fs, FR_DISK_ERR);
			}
#endif
			fp->dsect = sect;
		}
		wcnt = SS(fp->fs) - ((UINT)fp->fptr % SS(fp->fs));/* o͊ɏՕɕzu */
		if (wcnt > btw) wcnt = btw;
#if _FS_TINY
		if (move_window(fp->fs, fp->dsect) != FR_OK)	/* ړ */
			ABORT(fp->fs, FR_DISK_ERR);
		mem_cpy(&fp->fs->win[fp->fptr % SS(fp->fs)], wbuff, wcnt);	/* K */
		fp->fs->wflag = 1;
#else
		mem_cpy(&fp->buf[fp->fptr % SS(fp->fs)], wbuff, wcnt);	/* K */
		fp->flag |= FA__DIRTY;
#endif
	}

	if (fp->fptr > fp->fsize) fp->fsize = fp->fptr;	/* ߂ꂽꍇ̧ٗeʍXV */
	fp->flag |= FA__WRITTEN;						/* ̧ٕύX׸ސݒ */

	LEAVE_FF(fp->fs, FR_OK);
}

/*-----------------------------------------------------------------------*/
/* ̧ٓ                                                              */
/*-----------------------------------------------------------------------*/

FRESULT f_sync (
	FIL* fp		/* ّ̧Ώەւ̈ʒuwq */
)
{
	FRESULT res;
	DWORD tm;
	BYTE *dir;


	res = validate(fp);					/* Ώە̗L */
	if (res == FR_OK) {
		if (fp->flag & FA__WRITTEN) {	/* ̧قɉύXL肩? */
#if !_FS_TINY
			if (fp->flag & FA__DIRTY) {	/* KvȂAꂽް߂ */
				if (disk_write(fp->fs->drv, fp->buf, fp->dsect, 1) != RES_OK)
					LEAVE_FF(fp->fs, FR_DISK_ERR);
				fp->flag &= ~FA__DIRTY;
			}
#endif
			/* ިڸؓXV */
			res = move_window(fp->fs, fp->dir_sect);
			if (res == FR_OK) {
				dir = fp->dir_ptr;
				dir[DIR_Attr] |= AM_ARC;					/*  ޯĐݒ */
				ST_DWORD(dir + DIR_FileSize, fp->fsize);	/* ̧ٗeʍXV */
				st_clust(dir, fp->sclust);					/* Jn׽XV */
				tm = GET_FATTIME();							/* ύXXV */
				ST_DWORD(dir + DIR_WrtTime, tm);
				ST_WORD(dir + DIR_LstAccDate, 0);
				fp->flag &= ~FA__WRITTEN;
				fp->fs->wflag = 1;
				res = sync_fs(fp->fs);
			}
		}
	}

	LEAVE_FF(fp->fs, res);
}

#endif /* !_FS_READONLY */

/*-----------------------------------------------------------------------*/
/* ̧ٕ                                                              */
/*-----------------------------------------------------------------------*/

FRESULT f_close (
	FIL *fp		/* ׂّ̧Ώەւ̈ʒuwq */
)
{
	FRESULT res;


#if !_FS_READONLY
	res = f_sync(fp);					/* ꂽްo */
	if (res == FR_OK)
#endif
	{
		res = validate(fp);				/* حю{ */
		if (res == FR_OK) {
#if _FS_REENTRANT
			FATFS *fs = fp->fs;
#endif
#if _FS_LOCK
			res = dec_lock(fp->lockid);	/* ̧يJv팸 */
			if (res == FR_OK)
#endif
				fp->fs = 0;				/* ّ̧Ώە */
#if _FS_REENTRANT
			unlock_fs(fs, FR_OK);		/* حщ */
#endif
		}
	}
	return res;
}

/*-----------------------------------------------------------------------*/
/* ݂ިڸ؂܂݂͌ײނύXA݂ިڸ؂擾            */
/*-----------------------------------------------------------------------*/

#if _FS_RPATH >= 1
#if _VOLUMES >= 2
FRESULT f_chdrive (
	const TCHAR* path		/* ײޔԍ */
)
{
	int vol;

	vol = get_ldnumber(&path);
	if (vol < 0) return FR_INVALID_DRIVE;

	CurrVol = (BYTE)vol;

	return FR_OK;
}
#endif

FRESULT f_chdir (
	const TCHAR* path	/*ިڸ ߽ւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj;
	DEFINE_NAMEBUF;

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &path, 0);
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);		/* ߽ǋy */
		FREE_BUF();
		if (res == FR_OK) {					/* Ōp */
			if (!dj.dir) {
				dj.fs->cdir = dj.sclust;	/* Jnިڸ؂ꎩg */
			} else {
				if (dj.dir[DIR_Attr] & AM_DIR)	/* ިڸ؂ɓB */
					dj.fs->cdir = ld_clust(dj.fs, dj.dir);
				else
					res = FR_NO_PATH;		/* BA̧ */
			}
		}
		if (res == FR_NO_FILE) res = FR_NO_PATH;
	}

	LEAVE_FF(dj.fs, res);
}

#if _FS_RPATH >= 2
FRESULT f_getcwd (
	TCHAR* buff,	/* ިڸ ߽ւ̈ʒuwq */
	UINT len		/* ߽̑傫 */
)
{
	FRESULT res;
	DIR dj;
	UINT i, n;
	DWORD ccl;
	TCHAR *tp;
	FILINFO fno;
	DEFINE_NAMEBUF;

	*buff = 0;
	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, (const TCHAR**)&buff, 0);	/* ݂حю擾 */
	if (res == FR_OK) {
		INIT_BUF(dj);
		i = len;			/* ɏՕ̒(ިڸ ) */
		dj.sclust = dj.fs->cdir;			/* ݂ިڸ؂㑤ިڸؒǋyJn */
		while ((ccl = dj.sclust) != 0) {	/* ݂ިڸ؂ިڸ؂łԌJԂ */
			res = dir_sdi(&dj, 1);			/* eިڸ؎擾 */
			if (res != FR_OK) break;
			res = dir_read(&dj, 0);
			if (res != FR_OK) break;
			dj.sclust = ld_clust(dj.fs, dj.dir);	/* eިڸ؂֍s */
			res = dir_sdi(&dj, 0);
			if (res != FR_OK) break;
			do {							/* qިڸ؂Ɍq{ */
				res = dir_read(&dj, 0);
				if (res != FR_OK) break;
				if (ccl == ld_clust(dj.fs, dj.dir)) break;	/*  */
				res = dir_next(&dj, 0);	
			} while (res == FR_OK);
			if (res == FR_NO_FILE) res = FR_INT_ERR;/* 'not found's */
			if (res != FR_OK) break;
#if _USE_LFN
			fno.lfname = buff;
			fno.lfsize = i;
#endif
			get_fileinfo(&dj, &fno);		/* ިڸؖ擾ĊɏՕ։ */
			tp = fno.fname;
#if _USE_LFN
			if (*buff) tp = buff;
#endif
			for (n = 0; tp[n]; n++) ;
			if (i < n + 3) {
				res = FR_NOT_ENOUGH_CORE; break;
			}
			while (n) buff[--i] = tp[--n];
			buff[--i] = '/';
		}
		tp = buff;
		if (res == FR_OK) {
#if _VOLUMES >= 2
			*tp++ = '0' + CurrVol;			/* ײޔԍzu */
			*tp++ = ':';
#endif
			if (i == len) {					/* {ިڸ */
				*tp++ = '/';
			} else {						/* ިڸ */
				do		/* ςݏグ()߽ǉ */
					*tp++ = buff[i++];
				while (i < len);
			}
		}
		*tp = 0;
		FREE_BUF();
	}

	LEAVE_FF(dj.fs, res);
}
#endif /* _FS_RPATH >= 2 */
#endif /* _FS_RPATH >= 1 */

#if _FS_MINIMIZE <= 2
/*-----------------------------------------------------------------------*/
/* ̧R/Wʒuwq                                                 */
/*-----------------------------------------------------------------------*/

FRESULT f_lseek (
	FIL* fp,		/* ّ̧Ώەւ̈ʒuwq */
	DWORD ofs		/* ِ̧擪̧وʒuwq */
)
{
	FRESULT res;
	DWORD clst, bcs, nsect, ifptr;
#if _USE_FASTSEEK
	DWORD cl, pcl, ncl, tcl, dsc, tlen, ulen, *tbl;
#endif


	res = validate(fp);					/* Ώە̗L */
	if (res != FR_OK) LEAVE_FF(fp->fs, res);
	if (fp->err)						/* ُ팟 */
		LEAVE_FF(fp->fs, (FRESULT)fp->err);

#if _USE_FASTSEEK
	if (fp->cltbl) {	/* 񌟍 */
		if (ofs == CREATE_LINKMAP) {	/* CLMT쐬 */
			tbl = fp->cltbl;
			tlen = *tbl++; ulen = 2;	/* ^ꂽ\̑傫ƕKvƂ\̑傫 */
			cl = fp->sclust;			/* A̐擪 */
			if (cl) {
				do {
					/* fЎ擾 */
					tcl = cl; ncl = 0; ulen += 2;	/* 擪AAgp */
					do {
						pcl = cl; ncl++;
						cl = get_fat(fp->fs, cl);
						if (cl <= 1) ABORT(fp->fs, FR_INT_ERR);
						if (cl == 0xFFFFFFFF) ABORT(fp->fs, FR_DISK_ERR);
					} while (cl == pcl + 1);
					if (ulen <= tlen) {		/* fЂ̒Ɛ擪i[ */
						*tbl++ = ncl; *tbl++ = tcl;
					}
				} while (cl < fp->fs->n_fatent);	/* A̍Ō܂ŌJԂ */
			}
			*fp->cltbl = ulen;	/* gpڐ */
			if (ulen <= tlen)
				*tbl = 0;		/* \I */
			else
				res = FR_NOT_ENOUGH_CORE;	/* ^ꂽ\̑傫Kv */

		} else {						/* 񌟍 */
			if (ofs > fp->fsize)		/* ̧ٗeʂŕψʂ𐧌 */
				ofs = fp->fsize;
			fp->fptr = ofs;				/* ̧وʒuwqݒ */
			if (ofs) {
				fp->clust = clmt_clust(fp, ofs - 1);
				dsc = clust2sect(fp->fs, fp->clust);
				if (!dsc) ABORT(fp->fs, FR_INT_ERR);
				dsc += (ofs - 1) / SS(fp->fs) & (fp->fs->csize - 1);
				if (fp->fptr % SS(fp->fs) && dsc != fp->dsect) {	/* KvȂA Ăі */
#if !_FS_TINY
#if !_FS_READONLY
					if (fp->flag & FA__DIRTY) {		/* ύXꂽ ߂ */
						if (disk_write(fp->fs->drv, fp->buf, fp->dsect, 1) != RES_OK)
							ABORT(fp->fs, FR_DISK_ERR);
						fp->flag &= ~FA__DIRTY;
					}
#endif
					if (disk_read(fp->fs->drv, fp->buf, dsc, 1) != RES_OK)	/* ݂̾ݒ */
						ABORT(fp->fs, FR_DISK_ERR);
#endif
					fp->dsect = dsc;
				}
			}
		}
	} else
#endif

	/* W */
	{
		if (ofs > fp->fsize					/* ǂݍݐpŁA̧ٗeʂŕψʂ𐧌 */
#if !_FS_READONLY
			 && !(fp->flag & FA_WRITE)
#endif
			) ofs = fp->fsize;

		ifptr = fp->fptr;
		fp->fptr = nsect = 0;
		if (ofs) {
			bcs = (DWORD)fp->fs->csize * SS(fp->fs);	/* ׽e(޲) */
			if (ifptr > 0 &&
				(ofs - 1) / bcs >= (ifptr - 1) / bcs) {	/* ܂͌㑱ւ̌A */
				fp->fptr = (ifptr - 1) & ~(bcs - 1);	/* ̸݂׽Jn */
				ofs -= fp->fptr;
				clst = fp->clust;
			} else {									/* 둤׽֌A */
				clst = fp->sclust;						/* 擪׽Jn */
#if !_FS_READONLY
				if (clst == 0) {						/* ׽AȂȂAVKA쐬 */
					clst = create_chain(fp->fs, 0);
					if (clst == 1) ABORT(fp->fs, FR_INT_ERR);
					if (clst == 0xFFFFFFFF) ABORT(fp->fs, FR_DISK_ERR);
					fp->sclust = clst;
				}
#endif
				fp->clust = clst;
			}
			if (clst != 0) {
				while (ofs > bcs) {						/* ׽ǋyJԂ */
#if !_FS_READONLY
					if (fp->flag & FA_WRITE) {			/* ݓ삩ۂ */
						clst = create_chain(fp->fs, clst);	/* ݓȂAL */
						if (clst == 0) {				/* ިtA̧ٗeʐ */
							ofs = bcs; break;
						}
					} else
#endif
						clst = get_fat(fp->fs, clst);	/* ݓłȂ΁A׽Aǋy */
					if (clst == 0xFFFFFFFF) ABORT(fp->fs, FR_DISK_ERR);
					if (clst <= 1 || clst >= fp->fs->n_fatent) ABORT(fp->fs, FR_INT_ERR);
					fp->clust = clst;
					fp->fptr += bcs;
					ofs -= bcs;
				}
				fp->fptr += ofs;
				if (ofs % SS(fp->fs)) {
					nsect = clust2sect(fp->fs, clst);	/* ݂̾ */
					if (!nsect) ABORT(fp->fs, FR_INT_ERR);
					nsect += ofs / SS(fp->fs);
				}
			}
		}
		if (fp->fptr % SS(fp->fs) && nsect != fp->dsect) {	/* KvȂA 𖞂 */
#if !_FS_TINY
#if !_FS_READONLY
			if (fp->flag & FA__DIRTY) {			/* ύX ߂ */
				if (disk_write(fp->fs->drv, fp->buf, fp->dsect, 1) != RES_OK)
					ABORT(fp->fs, FR_DISK_ERR);
				fp->flag &= ~FA__DIRTY;
			}
#endif
			if (disk_read(fp->fs->drv, fp->buf, nsect, 1) != RES_OK)	/*  𖞂 */
				ABORT(fp->fs, FR_DISK_ERR);
#endif
			fp->dsect = nsect;
		}
#if !_FS_READONLY
		if (fp->fptr > fp->fsize) {			/* ̧ٗeʂꂽȂA̧ٕύX׸ސݒ */
			fp->fsize = fp->fptr;
			fp->flag |= FA__WRITTEN;
		}
#endif
	}

	LEAVE_FF(fp->fs, res);
}

#if _FS_MINIMIZE <= 1
/*-----------------------------------------------------------------------*/
/* ިڸؑΏە쐬                                                     */
/*-----------------------------------------------------------------------*/

FRESULT f_opendir (
	DIR* dp,			/* 쐬ިڸؑΏەւ̈ʒuwq */
	const TCHAR* path	/* ިڸ ߽ւ̈ʒuwq */
)
{
	FRESULT res;
	FATFS* fs;
	DEFINE_NAMEBUF;


	if (!dp) return FR_INVALID_OBJECT;

	/* _ײޔԍ擾 */
	res = find_volume(&fs, &path, 0);
	if (res == FR_OK) {
		dp->fs = fs;
		INIT_BUF(*dp);
		res = follow_path(dp, path);			/* ިڸ؂߽ǋy */
		FREE_BUF();
		if (res == FR_OK) {						/* Ōp */
			if (dp->dir) {						/* ިڸ؂ꎩgłȂ */
				if (dp->dir[DIR_Attr] & AM_DIR)	/* Ώە͕ިڸ */
					dp->sclust = ld_clust(fs, dp->dir);
				else							/* Ώە̧ */
					res = FR_NO_PATH;
			}
			if (res == FR_OK) {
				dp->id = fs->id;
				res = dir_sdi(dp, 0);			/* ިڸ؂߂ */
#if _FS_LOCK
				if (res == FR_OK) {
					if (dp->sclust) {
						dp->lockid = inc_lock(dp, 0);	/* ިڸ؂{ */
						if (!dp->lockid)
							res = FR_TOO_MANY_OPEN_FILES;
					} else {
						dp->lockid = 0;	/* {ިڸ؂͎{ȂƂKv */
					}
				}
#endif
			}
		}
		if (res == FR_NO_FILE) res = FR_NO_PATH;
	}
	if (res != FR_OK) dp->fs = 0;		/* ֐sȂAިڸؑΏە */

	LEAVE_FF(fs, res);
}

/*-----------------------------------------------------------------------*/
/* ިڸؕ                                                           */
/*-----------------------------------------------------------------------*/

FRESULT f_closedir (
	DIR *dp		/* ׂިڸؑΏەւ̈ʒuwq */
)
{
	FRESULT res;

	res = validate(dp);
	if (res == FR_OK) {
#if _FS_REENTRANT
		FATFS *fs = dp->fs;
#endif
#if _FS_LOCK
		if (dp->lockid)				/* ިڸ؊Jv */
			res = dec_lock(dp->lockid);
		if (res == FR_OK)
#endif
			dp->fs = 0;				/* ިڸؑΏە */
#if _FS_REENTRANT
		unlock_fs(fs, FR_OK);		/* حщ */
#endif
	}
	return res;
}

/*-----------------------------------------------------------------------*/
/* Aިڸؓǂݍ                                             */
/*-----------------------------------------------------------------------*/

FRESULT f_readdir (
	DIR* dp,			/* JިڸؑΏەւ̈ʒuwq */
	FILINFO* fno		/* Ԃ߂ُ̧ւ̈ʒuwq */
)
{
	FRESULT res;
	DEFINE_NAMEBUF;

	res = validate(dp);						/* Ώە̗L */
	if (res == FR_OK) {
		if (!fno) {
			res = dir_sdi(dp, 0);			/* ިڸؑΏە߂ */
		} else {
			INIT_BUF(*dp);
			res = dir_read(dp, 0);			/* ړǂݍ */
			if (res == FR_NO_FILE) {		/* ިڸ؂̍ŌɓB */
				dp->sect = 0;
				res = FR_OK;
			}
			if (res == FR_OK) {				/* L */
				get_fileinfo(dp, fno);		/* Ώە擾 */
				res = dir_next(dp, 0);		/* wWɐis */
				if (res == FR_NO_FILE) {
					dp->sect = 0;
					res = FR_OK;
				}
			}
			FREE_BUF();
		}
	}

	LEAVE_FF(dp->fs, res);
}

#if _USE_FIND
/*-----------------------------------------------------------------------*/
/* ̧ق{                                                          */
/*-----------------------------------------------------------------------*/

FRESULT f_findnext (
	DIR* dp,		/* JިڸؑΏەւ̈ʒuwq */
	FILINFO* fno	/* ُ̧\̂ւ̈ʒuwq */
)
{
	FRESULT res;

	for (;;) {
		res = f_readdir(dp, fno);		/* ިڸ؍ڎ擾 */
		if (res != FR_OK || !fno || !fno->fname[0]) break;	/* ꂩُ̈܂ިڸ؂̍ŌŁAI */
#if _USE_LFN
		if (fno->lfname && pattern_matching(dp->pat, fno->lfname, 0, 0)) break;	/* ݂ȂALFN */
#endif
		if (pattern_matching(dp->pat, fno->fname, 0, 0)) break;	/* SFN */
	}
	return res;
}

/*-----------------------------------------------------------------------*/
/* ̧ق{                                                      */
/*-----------------------------------------------------------------------*/

FRESULT f_findfirst (
	DIR* dp,				/* ިڸؑΏەւ̈ʒuwq */
	FILINFO* fno,			/* ُ̧\̂ւ̈ʒuwq */
	const TCHAR* path,		/* J߂ިڸ؂ւ̈ʒuwq */
	const TCHAR* pattern	/* vlւ̈ʒuwq */
)
{
	FRESULT res;

	dp->pat = pattern;		/* lւ̈ʒuwqۑ */
	res = f_opendir(dp, path);		/* ړIΏިڸ؂J */
	if (res == FR_OK)
		res = f_findnext(dp, fno);	/* 񌟍 */
	return res;
}
#endif	/* _USE_FIND */

#if _FS_MINIMIZE == 0
/*-----------------------------------------------------------------------*/
/* ُ̧Ԏ擾                                                          */
/*-----------------------------------------------------------------------*/

FRESULT f_stat (
	const TCHAR* path,	/* ̧ ߽ւ̈ʒuwq */
	FILINFO* fno		/* Ԃ߂ُ̧ւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj;
	DEFINE_NAMEBUF;

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &path, 0);
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);	/* ̧ ߽ǋy */
		if (res == FR_OK) {				/* Ȃp */
			if (dj.dir) {		/* Ώە */
				if (fno) get_fileinfo(&dj, fno);
			} else {			/* {ިڸ */
				res = FR_INVALID_NAME;
			}
		}
		FREE_BUF();
	}

	LEAVE_FF(dj.fs, res);
}

#if !_FS_READONLY
/*-----------------------------------------------------------------------*/
/* 󂫸׽擾                                                        */
/*-----------------------------------------------------------------------*/

FRESULT f_getfree (
	const TCHAR* path,	/* _ײޔԍ߽ */
	DWORD* nclst,		/* 󂫸׽Ԃϐւ̈ʒuwq */
	FATFS** fatfs		/* Ή̧ ёΏەւ̈ʒuwqԂ߂̈ʒuwq */
)
{
	FRESULT res;
	FATFS *fs;
	DWORD nfree, clst, sect, stat;
	UINT i;
	BYTE fat, *p;

	/* _ײޔԍ擾 */
	res = find_volume(fatfs, &path, 0);
	fs = *fatfs;
	if (res == FR_OK) {
		/* free_clustLȂAS׽ȂŕԂ */
		if (fs->free_clust <= fs->n_fatent - 2) {
			*nclst = fs->free_clust;
		} else {
			/* 󂫸׽F擾 */
			fat = fs->fs_type;
			nfree = 0;
			if (fat == FS_FAT12) {	/* 񐮗: ʏٰ݌oRFAT */
				clst = 2;
				do {
					stat = get_fat(fs, clst);
					if (stat == 0xFFFFFFFF) { res = FR_DISK_ERR; break; }
					if (stat == 1) { res = FR_INT_ERR; break; }
					if (stat == 0) nfree++;
				} while (++clst < fs->n_fatent);
			} else {				/* : FAT */
				clst = fs->n_fatent; sect = fs->fatbase;
				i = 0; p = 0;
				do {
					if (!i) {
						res = move_window(fs, sect++);
						if (res != FR_OK) break;
						p = fs->win;
						i = SS(fs);
					}
					if (fat == FS_FAT16) {
						if (LD_WORD(p) == 0) nfree++;
						p += 2; i -= 2;
					} else {
						if ((LD_DWORD(p) & 0x0FFFFFFF) == 0) nfree++;
						p += 4; i -= 4;
					}
				} while (--clst);
			}
			fs->free_clust = nfree;	/* free_clustL */
			fs->fsi_flag |= 1;		/* ̧ я͍XVׂ */
			*nclst = nfree;			/* 󂫸׽Ԃ */
		}
	}
	LEAVE_FF(fs, res);
}

/*-----------------------------------------------------------------------*/
/* ِ̧؂l                                                          */
/*-----------------------------------------------------------------------*/

FRESULT f_truncate (
	FIL* fp		/* ّ̧Ώەւ̈ʒuwq */
)
{
	FRESULT res;
	DWORD ncl;

	res = validate(fp);						/* Ώە̗L */
	if (res == FR_OK) {
		if (fp->err) {						/* ُ팟 */
			res = (FRESULT)fp->err;
		} else {
			if (!(fp->flag & FA_WRITE))		/* ʌ */
				res = FR_DENIED;
		}
	}
	if (res == FR_OK) {
		if (fp->fsize > fp->fptr) {
			fp->fsize = fp->fptr;	/* ̧ٗeʂ݂R/W_ɐݒ */
			fp->flag |= FA__WRITTEN;
			if (fp->fptr == 0) {	/* ̧ٗe=0ݒ莞A׽AŜ */
				res = remove_chain(fp->fs, fp->sclust);
				fp->sclust = 0;
			} else {				/* ̧ق̈ꕔ؂lߎAc̸׽ */
				ncl = get_fat(fp->fs, fp->clust);
				res = FR_OK;
				if (ncl == 0xFFFFFFFF) res = FR_DISK_ERR;
				if (ncl == 1) res = FR_INT_ERR;
				if (res == FR_OK && ncl < fp->fs->n_fatent) {
					res = put_fat(fp->fs, fp->clust, 0x0FFFFFFF);
					if (res == FR_OK) res = remove_chain(fp->fs, ncl);
				}
			}
#if !_FS_TINY
			if (res == FR_OK && (fp->flag & FA__DIRTY)) {
				if (disk_write(fp->fs->drv, fp->buf, fp->dsect, 1) != RES_OK)
					res = FR_DISK_ERR;
				else
					fp->flag &= ~FA__DIRTY;
			}
#endif
		}
		if (res != FR_OK) fp->err = (FRESULT)res;
	}

	LEAVE_FF(fp->fs, res);
}

/*-----------------------------------------------------------------------*/
/* ̧ق܂ިڸ؂폜                                               */
/*-----------------------------------------------------------------------*/

FRESULT f_unlink (
	const TCHAR* path		/* ̧ق܂ިڸĂ߽ւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj, sdj;
	BYTE *dir;
	DWORD dclst = 0;
	DEFINE_NAMEBUF;

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &path, 1);
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);		/* ̧ ߽ǋy */
		if (_FS_RPATH && res == FR_OK && (dj.fn[NSFLAG] & NS_DOT))
			res = FR_INVALID_NAME;			/* _s\ */
#if _FS_LOCK
		if (res == FR_OK) res = chk_lock(&dj, 2);	/* JΏەs\ */
#endif
		if (res == FR_OK) {					/* Ώە\ */
			dir = dj.dir;
			if (!dir) {
				res = FR_INVALID_NAME;		/* ިڸ؏s\ */
			} else {
				if (dir[DIR_Attr] & AM_RDO)
					res = FR_DENIED;		/* R/OΏەs\ */
			}
			if (res == FR_OK) {
				dclst = ld_clust(dj.fs, dir);
				if (dclst && (dir[DIR_Attr] & AM_DIR)) {	/* ިڸ؂? */
#if _FS_RPATH
					if (dclst == dj.fs->cdir) {		 		/* ݂ިڸ؂? */
						res = FR_DENIED;
					} else
#endif
					{
						mem_cpy(&sdj, &dj, sizeof (DIR));	/* ިڸ؂J */
						sdj.sclust = dclst;
						res = dir_sdi(&sdj, 2);
						if (res == FR_OK) {
							res = dir_read(&sdj, 0);			/* (_)ړǂݍ */
							if (res == FR_OK) res = FR_DENIED;	/* łȂ? (s\) */
							if (res == FR_NO_FILE) res = FR_OK;	/* ? (\) */
						}
					}
				}
			}
			if (res == FR_OK) {
				res = dir_remove(&dj);		/* ިڸؓ */
				if (res == FR_OK && dclst)	/* ݂ȂA׽A */
					res = remove_chain(dj.fs, dclst);
				if (res == FR_OK) res = sync_fs(dj.fs);
			}
		}
		FREE_BUF();
	}

	LEAVE_FF(dj.fs, res);
}

/*-----------------------------------------------------------------------*/
/* ިڸ؍쐬                                                           */
/*-----------------------------------------------------------------------*/

FRESULT f_mkdir (
	const TCHAR* path		/* ިڸ ߽ւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj;
	BYTE *dir, n;
	DWORD dsc, dcl, pcl, tm = GET_FATTIME();
	DEFINE_NAMEBUF;

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &path, 1);
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);			/* ̧ ߽ǋy */
		if (res == FR_OK) res = FR_EXIST;		/* ꖼ̉ꂩ̑Ώە */
		if (_FS_RPATH && res == FR_NO_FILE && (dj.fn[NSFLAG] & NS_DOT))
			res = FR_INVALID_NAME;
		if (res == FR_NO_FILE) {				/* Vިڸ؍쐬\ */
			dcl = create_chain(dj.fs, 0);		/* Vިڸؕ\pɸ׽蓖 */
			res = FR_OK;
			if (dcl == 0) res = FR_DENIED;		/* V׽蓖ċԂȂ */
			if (dcl == 1) res = FR_INT_ERR;
			if (dcl == 0xFFFFFFFF) res = FR_DISK_ERR;
			if (res == FR_OK)					/* FATo */
				res = sync_window(dj.fs);
			if (res == FR_OK) {					/* Vިڸؕ\ */
				dsc = clust2sect(dj.fs, dcl);
				dir = dj.fs->win;
				mem_set(dir, 0, SS(dj.fs));
				mem_set(dir + DIR_Name, ' ', 11);	/* "."쐬 */
				dir[DIR_Name] = '.';
				dir[DIR_Attr] = AM_DIR;
				ST_DWORD(dir + DIR_WrtTime, tm);
				st_clust(dir, dcl);
				mem_cpy(dir + SZ_DIRE, dir, SZ_DIRE); 	/* ".."쐬 */
				dir[SZ_DIRE + 1] = '.'; pcl = dj.sclust;
				if (dj.fs->fs_type == FS_FAT32 && pcl == dj.fs->dirbase)
					pcl = 0;
				st_clust(dir + SZ_DIRE, pcl);
				for (n = dj.fs->csize; n; n--) {	/* _Č㑱 */
					dj.fs->winsect = dsc++;
					dj.fs->wflag = 1;
					res = sync_window(dj.fs);
					if (res != FR_OK) break;
					mem_set(dir, 0, SS(dj.fs));
				}
			}
			if (res == FR_OK) res = dir_register(&dj);	/* Ώەިڸ؂ɓo^ */
			if (res != FR_OK) {
				remove_chain(dj.fs, dcl);			/* o^s\A׽A */
			} else {
				dir = dj.dir;
				dir[DIR_Attr] = AM_DIR;				/*  */
				ST_DWORD(dir + DIR_WrtTime, tm);	/* 쐬 */
				st_clust(dir, dcl);					/* \̊Jn׽ */
				dj.fs->wflag = 1;
				res = sync_fs(dj.fs);
			}
		}
		FREE_BUF();
	}

	LEAVE_FF(dj.fs, res);
}

/*-----------------------------------------------------------------------*/
/* ύX                                                              */
/*-----------------------------------------------------------------------*/

FRESULT f_chmod (
	const TCHAR* path,	/* ̧ ߽ւ̈ʒuwq */
	BYTE attr,			/* ޯ */
	BYTE mask			/* ύX邽߂̑Օ */
)
{
	FRESULT res;
	DIR dj;
	BYTE *dir;
	DEFINE_NAMEBUF;

	res = find_volume(&dj.fs, &path, 1);	/* _ײޔԍ擾 */
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);		/* ̧ ߽ǋy */
		FREE_BUF();
		if (_FS_RPATH && res == FR_OK && (dj.fn[NSFLAG] & NS_DOT))
			res = FR_INVALID_NAME;
		if (res == FR_OK) {
			dir = dj.dir;
			if (!dir) {						/* {ިڸ؂? */
				res = FR_INVALID_NAME;
			} else {						/* ̧ق܂͕ިڸ */
				mask &= AM_RDO|AM_HID|AM_SYS|AM_ARC;	/* LȑՕ */
				dir[DIR_Attr] = (attr & mask) | (dir[DIR_Attr] & (BYTE)~mask);	/* ύXɓKp */
				dj.fs->wflag = 1;
				res = sync_fs(dj.fs);
			}
		}
	}

	LEAVE_FF(dj.fs, res);
}

/*-----------------------------------------------------------------------*/
/* ̧/ިڸ؉                                                      */
/*-----------------------------------------------------------------------*/

FRESULT f_rename (
	const TCHAR* path_old,	/* Ώەւ̈ʒuwq */
	const TCHAR* path_new	/* VOւ̈ʒuwq */
)
{
	FRESULT res;
	DIR djo, djn;
	BYTE buf[21], *dir;
	DWORD dw;
	DEFINE_NAMEBUF;

	/* Ώە̘_ײޔԍ擾 */
	res = find_volume(&djo.fs, &path_old, 1);
	if (res == FR_OK) {
		djn.fs = djo.fs;
		INIT_BUF(djo);
		res = follow_path(&djo, path_old);		/* Ώە */
		if (_FS_RPATH && res == FR_OK && (djo.fn[NSFLAG] & NS_DOT))
			res = FR_INVALID_NAME;
#if _FS_LOCK
		if (res == FR_OK) res = chk_lock(&djo, 2);
#endif
		if (res == FR_OK) {						/* Ώە */
			if (!djo.dir) {						/* {ިڸ؂? */
				res = FR_NO_FILE;
			} else {
				mem_cpy(buf, djo.dir + DIR_Attr, 21);	/* OΏەɂĂ̏ۑ */
				mem_cpy(&djn, &djo, sizeof (DIR));		/* ިڸؑΏەd */
				if (get_ldnumber(&path_new) >= 0)		/* ײޔԍ؂Ă𖳎 */
					res = follow_path(&djn, path_new);	/* ĐVΏەȂmF */
				else
					res = FR_INVALID_DRIVE;
				if (res == FR_OK) res = FR_EXIST;		/* VΏەŁA */
				if (res == FR_NO_FILE) { 				/* L߽ŖȌՓ˂Ȃ */
					res = dir_register(&djn);			/* Vo^ */
					if (res == FR_OK) {
/* ꂩ̊荞݂Ndvȗ̈̊Jn */
						dir = djn.dir;					/* OΏەɂĂ̏𕡎 */
						mem_cpy(dir + 13, buf + 2, 19);
						dir[DIR_Attr] = buf[0] | AM_ARC;
						djo.fs->wflag = 1;
						if ((dir[DIR_Attr] & AM_DIR) && djo.sclust != djn.sclust) {	/* KvȂAިڸ؂".."XV */
							dw = clust2sect(djo.fs, ld_clust(djo.fs, dir));
							if (!dw) {
								res = FR_INT_ERR;
							} else {
								res = move_window(djo.fs, dw);
								dir = djo.fs->win + SZ_DIRE * 1;	/* ".."ւ̈ʒuwq */
								if (res == FR_OK && dir[1] == '.') {
									st_clust(dir, djn.sclust);
									djo.fs->wflag = 1;
								}
							}
						}
						if (res == FR_OK) {
							res = dir_remove(&djo);		/*  */
							if (res == FR_OK)
								res = sync_fs(djo.fs);
						}
/* dvȗ̈̍Ō */
					}
				}
			}
		}
		FREE_BUF();
	}

	LEAVE_FF(djo.fs, res);
}

/*-----------------------------------------------------------------------*/
/* ύX                                                            */
/*-----------------------------------------------------------------------*/

FRESULT f_utime (
	const TCHAR* path,	/* ̧/ިڸ؂̖Oւ̈ʒuwq */
	const FILINFO* fno	/* ݒ肷鎞ւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj;
	BYTE *dir;
	DEFINE_NAMEBUF;

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &path, 1);
	if (res == FR_OK) {
		INIT_BUF(dj);
		res = follow_path(&dj, path);	/* ̧ ߽ǋy */
		FREE_BUF();
		if (_FS_RPATH && res == FR_OK && (dj.fn[NSFLAG] & NS_DOT))
			res = FR_INVALID_NAME;
		if (res == FR_OK) {
			dir = dj.dir;
			if (!dir) {					/* {ިڸ */
				res = FR_INVALID_NAME;
			} else {					/* ̧ق܂͕ިڸ */
				ST_WORD(dir + DIR_WrtTime, fno->ftime);
				ST_WORD(dir + DIR_WrtDate, fno->fdate);
				dj.fs->wflag = 1;
				res = sync_fs(dj.fs);
			}
		}
	}

	LEAVE_FF(dj.fs, res);
}

#endif /* !_FS_READONLY */
#endif /* _FS_MINIMIZE == 0 */
#endif /* _FS_MINIMIZE <= 1 */
#endif /* _FS_MINIMIZE <= 2 */

#if _USE_LABEL
/*-----------------------------------------------------------------------*/
/* ح َ擾                                                       */
/*-----------------------------------------------------------------------*/

FRESULT f_getlabel (
	const TCHAR* path,	/* _ײޔԍ߽ */
	TCHAR* label,		/* ح قԂɏՕւ̈ʒuwq */
	DWORD* vsn			/* حђʔԂԂϐւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj;
	UINT i, j;
#if _USE_LFN && _LFN_UNICODE
	WCHAR w;
#endif

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &path, 0);

	/* ح َ擾 */
	if (res == FR_OK && label) {
		dj.sclust = 0;					/* {ިڸ؂J */
		res = dir_sdi(&dj, 0);
		if (res == FR_OK) {
			res = dir_read(&dj, 1);		/* AM_VOL擾 */
			if (res == FR_OK) {			/* ح ّ */
#if _USE_LFN && _LFN_UNICODE
				i = j = 0;
				do {
					w = (i < 11) ? dj.dir[i++] : ' ';
					if (IsDBCS1(w) && i < 11 && IsDBCS2(dj.dir[i]))
						w = w << 8 | dj.dir[i++];
					label[j++] = ff_convert(w, 1);	/* OEMUnicode */
				} while (j < 11);
#else
				mem_cpy(label, dj.dir, 11);
#endif
				j = 11;
				do {
					label[j] = 0;
					if (!j) break;
				} while (label[--j] == ' ');
			}
			if (res == FR_NO_FILE) {	/* قȂANULLԂ */
				label[0] = 0;
				res = FR_OK;
			}
		}
	}

	/* حђʔԎ擾 */
	if (res == FR_OK && vsn) {
		res = move_window(dj.fs, dj.fs->volbase);
		if (res == FR_OK) {
			i = dj.fs->fs_type == FS_FAT32 ? BS_VolID32 : BS_VolID;
			*vsn = LD_DWORD(&dj.fs->win[i]);
		}
	}

	LEAVE_FF(dj.fs, res);
}

#if !_FS_READONLY
/*-----------------------------------------------------------------------*/
/* ح ِݒ                                                       */
/*-----------------------------------------------------------------------*/

FRESULT f_setlabel (
	const TCHAR* label	/* ݒ肷ح قւ̈ʒuwq */
)
{
	FRESULT res;
	DIR dj;
	BYTE vn[11];
	UINT i, j, sl;
	WCHAR w;
	DWORD tm;

	/* _ײޔԍ擾 */
	res = find_volume(&dj.fs, &label, 1);
	if (res) LEAVE_FF(dj.fs, res);

	/* ިڸ،`ح ٍ쐬 */
	vn[0] = 0;
	for (sl = 0; label[sl]; sl++) ;				/* O̒擾 */
	for ( ; sl && label[sl - 1] == ' '; sl--) ;	/* s󔒏 */
	if (sl) {	/* ިڸ،`ح ٍ쐬 */
		i = j = 0;
		do {
#if _USE_LFN && _LFN_UNICODE
			w = ff_convert(ff_wtoupper(label[i++]), 0);
#else
			w = (BYTE)label[i++];
			if (IsDBCS1(w))
				w = (j < 10 && i < sl && IsDBCS2(label[i])) ? w << 8 | (BYTE)label[i++] : 0;
#if _USE_LFN
			w = ff_convert(ff_wtoupper(ff_convert(w, 1)), 0);
#else
			if (IsLower(w)) w -= 0x20;			/* ASCII啶 */
#ifdef _EXCVT
			if (w >= 0x80) w = ExCvt[w - 0x80];	/* g㑤(SBCS`) */
#else
			if (!_DF1S && w >= 0x80) w = 0;		/* gp (ASCII`) */
#endif
#endif
#endif
			if (!w || chk_chr("\"*+,.:;<=>\?[]|\x7F", w) || j >= (UINT)((w >= 0x100) ? 10 : 11)) /* ح قɑ΂閳p */
				LEAVE_FF(dj.fs, FR_INVALID_NAME);
			if (w >= 0x100) vn[j++] = (BYTE)(w >> 8);
			vn[j++] = (BYTE)w;
		} while (i < sl);
		while (j < 11) vn[j++] = ' ';	/* c̖Ö[U */
		if (vn[0] == DDEM) LEAVE_FF(dj.fs, FR_INVALID_NAME);	/* p(oDDEM) */
	}

	/* ح ِݒ */
	dj.sclust = 0;					/* {ިڸ؂J */
	res = dir_sdi(&dj, 0);
	if (res == FR_OK) {
		res = dir_read(&dj, 1);		/* AM_VOL擾 */
		if (res == FR_OK) {			/* ح ٔ */
			if (vn[0]) {
				mem_cpy(dj.dir, vn, 11);	/* ح ٖύX */
				tm = GET_FATTIME();
				ST_DWORD(dj.dir + DIR_WrtTime, tm);
			} else {
				dj.dir[0] = DDEM;			/* ح ُ */
			}
			dj.fs->wflag = 1;
			res = sync_fs(dj.fs);
		} else {					/* ح قȂA܂ُ͈ */
			if (res == FR_NO_FILE) {
				res = FR_OK;
				if (vn[0]) {				/* VKƂح ٍ쐬 */
					res = dir_alloc(&dj, 1);	/* ح ٗpɓ蓖 */
					if (res == FR_OK) {
						mem_set(dj.dir, 0, SZ_DIRE);	/* ح ِݒ */
						mem_cpy(dj.dir, vn, 11);
						dj.dir[DIR_Attr] = AM_VOL;
						tm = GET_FATTIME();
						ST_DWORD(dj.dir + DIR_WrtTime, tm);
						dj.fs->wflag = 1;
						res = sync_fs(dj.fs);
					}
				}
			}
		}
	}

	LEAVE_FF(dj.fs, res);
}

#endif /* !_FS_READONLY */
#endif /* _USE_LABEL */

/*-----------------------------------------------------------------------*/
/* ް𒼐ڂ̗œ](tiny`Ԃł̂ݗp\)                        */
/*-----------------------------------------------------------------------*/
#if _USE_FORWARD && _FS_TINY

FRESULT f_forward (
	FIL* fp, 						/* ّ̧Ώەւ̈ʒuwq */
	UINT (*func)(const BYTE*,UINT),	/* ֐ւ̈ʒuwq */
	UINT btf,						/* ]޲Đ */
	UINT* bf						/* ]޲Đւ̈ʒuwq */
)
{
	FRESULT res;
	DWORD remain, clst, sect;
	UINT rcnt;
	BYTE csect;


	*bf = 0;	/* ]޲Čv */

	res = validate(fp);								/* Ώ̗L */
	if (res != FR_OK) LEAVE_FF(fp->fs, res);
	if (fp->err)									/* ُ팟 */
		LEAVE_FF(fp->fs, (FRESULT)fp->err);
	if (!(fp->flag & FA_READ))						/* ʌ */
		LEAVE_FF(fp->fs, FR_DENIED);

	remain = fp->fsize - fp->fptr;
	if (btf > remain) btf = (UINT)remain;			/* c޲Ăbtf؂l */

	for ( ;  btf && (*func)(0, 0);					/* Sް]ꑽZɂȂ܂ŌJԂ */
		fp->fptr += rcnt, *bf += rcnt, btf -= rcnt) {
		csect = (BYTE)(fp->fptr / SS(fp->fs) & (fp->fs->csize - 1));	/* ׽̾ψ */
		if ((fp->fptr % SS(fp->fs)) == 0) {			/* Eォ? */
			if (!csect) {							/* ׽Eォ? */
				clst = (fp->fptr == 0) ?			/* ِ̧擪? */
					fp->sclust : get_fat(fp->fs, fp->clust);
				if (clst <= 1) ABORT(fp->fs, FR_INT_ERR);
				if (clst == 0xFFFFFFFF) ABORT(fp->fs, FR_DISK_ERR);
				fp->clust = clst;					/* ̸݂׽XV */
			}
		}
		sect = clust2sect(fp->fs, fp->clust);		/* ݂ް 擾 */
		if (!sect) ABORT(fp->fs, FR_INT_ERR);
		sect += csect;
		if (move_window(fp->fs, sect) != FR_OK)		/* ړ */
			ABORT(fp->fs, FR_DISK_ERR);
		fp->dsect = sect;
		rcnt = SS(fp->fs) - (WORD)(fp->fptr % SS(fp->fs));	/* ް] */
		if (rcnt > btf) rcnt = btf;
		rcnt = (*func)(&fp->fs->win[(WORD)fp->fptr % SS(fp->fs)], rcnt);
		if (!rcnt) ABORT(fp->fs, FR_INT_ERR);
	}

	LEAVE_FF(fp->fs, FR_OK);
}
#endif /* _USE_FORWARD */

#if _USE_MKFS && !_FS_READONLY
/*-----------------------------------------------------------------------*/
/* _ײނ̧ т쐬                                           */
/*-----------------------------------------------------------------------*/
#define N_ROOTDIR	512		/* FAT12/16p{ިڸؓ */
#define N_FATS		1		/* FAT(1܂2) */

FRESULT f_mkfs (
	const TCHAR* path,	/* _ײޔԍ */
	BYTE sfd,			/* ߰è݋K: 0:FDISK, 1:SFD */
	UINT au				/* ޲Ă܂;Pʂł̊蓖ĒPʂ̑傫 */
)
{
	static const WORD vst[] = { 1024,   512,  256,  128,   64,    32,   16,    8,    4,    2,   0};
	static const WORD cst[] = {32768, 16384, 8192, 4096, 2048, 16384, 8192, 4096, 2048, 1024, 512};
	int vol;
	BYTE fmt, md, sys, *tbl, pdrv, part;
	DWORD n_clst, vs, n, wsect;
	UINT i;
	DWORD b_vol, b_fat, b_dir, b_data;	/* LBA */
	DWORD n_vol, n_rsv, n_fat, n_dir;	/* 傫 */
	FATFS *fs;
	DSTATUS stat;
#if _USE_TRIM
	DWORD eb[2];
#endif

	/* tꂽײނ𒲍čƗ̈ */
	if (sfd > 1) return FR_INVALID_PARAMETER;
	vol = get_ldnumber(&path);
	if (vol < 0) return FR_INVALID_DRIVE;
	fs = FatFs[vol];
	if (!fs) return FR_NOT_ENABLED;
	fs->fs_type = 0;
	pdrv = LD2PD(vol);	/* ײ */
	part = LD2PT(vol);	/* ߰è (0:o, 1-4:߰èݕ\擾)*/

	/* ި擾 */
	stat = disk_initialize(pdrv);
	if (stat & STA_NOINIT) return FR_NOT_READY;
	if (stat & STA_PROTECT) return FR_WRITE_PROTECTED;
#if _MAX_SS != _MIN_SS		/* ި eʎ擾 */
	if (disk_ioctl(pdrv, GET_SECTOR_SIZE, &SS(fs)) != RES_OK || SS(fs) > _MAX_SS || SS(fs) < _MIN_SS)
		return FR_DISK_ERR;
#endif
	if (_MULTI_PARTITION && part) {
		/* MBR߰èݕ\߰èݏ擾 */
		if (disk_read(pdrv, fs->win, 0, 1) != RES_OK) return FR_DISK_ERR;
		if (LD_WORD(fs->win + BS_55AA) != 0xAA55) return FR_MKFS_ABORTED;
		tbl = &fs->win[MBR_Table + (part - 1) * SZ_PTE];
		if (!tbl[4]) return FR_MKFS_ABORTED;	/* ߰è݂Ȃ? */
		b_vol = LD_DWORD(tbl + 8);	/* حъJn */
		n_vol = LD_DWORD(tbl + 12);	/* حт̑傫 */
	} else {
		/* {֐߰èݍ쐬 */
		if (disk_ioctl(pdrv, GET_SECTOR_COUNT, &n_vol) != RES_OK || n_vol < 128)
			return FR_DISK_ERR;
		b_vol = (sfd) ? 0 : 63;		/* حъJn */
		n_vol -= b_vol;				/* حт̑傫 */
	}

	if (au & (au - 1)) au = 0;
	if (!au) {						/* AUI */
		vs = n_vol / (2000 / (SS(fs) / 512));
		for (i = 0; vs < vst[i]; i++) ;
		au = cst[i];
	}
	if (au >= _MIN_SS) au /= SS(fs);	/* ׽̾ */
	if (!au) au = 1;
	if (au > 128) au = 128;

	/* ׽FAT⏕`OvZ */
	n_clst = n_vol / au;
	fmt = FS_FAT12;
	if (n_clst >= MIN_FAT16) fmt = FS_FAT16;
	if (n_clst >= MIN_FAT32) fmt = FS_FAT32;

	/* FAT\̂̕ψʂƑ傫߂ */
	if (fmt == FS_FAT32) {
		n_fat = ((n_clst * 4) + 8 + SS(fs) - 1) / SS(fs);
		n_rsv = 32;
		n_dir = 0;
	} else {
		n_fat = (fmt == FS_FAT12) ? (n_clst * 3 + 1) / 2 + 3 : (n_clst * 2) + 4;
		n_fat = (n_fat + SS(fs) - 1) / SS(fs);
		n_rsv = 1;
		n_dir = (DWORD)N_ROOTDIR * SZ_DIRE / SS(fs);
	}
	b_fat = b_vol + n_rsv;				/* FAT̈Jn */
	b_dir = b_fat + n_fat * N_FATS;		/* ިڸؗ̈Jn */
	b_data = b_dir + n_dir;				/* ް̈Jn */
	if (n_vol < b_data + au - b_vol) return FR_MKFS_ABORTED;	/* Zح */

	/* (ׯ ؔ}̗p)򋫊Ê߂ްJn𐮗 */
	if (disk_ioctl(pdrv, GET_BLOCK_SIZE, &n) != RES_OK || !n || n > 32768) n = 1;
	n = (b_data + n - 1) & ~(n - 1);	/* ݂ްJnł߂̏ */
	n = (n - b_data) / N_FATS;
	if (fmt == FS_FAT32) {		/* FAT32:FATψʈړ */
		n_rsv += n;
		b_fat += n;
	} else {					/* FAT12/16:FATeʊg */
		n_fat += n;
	}

	/* ׽FAT⏕`̗L̍ŏI */
	n_clst = (n_vol - n_rsv - n_fat * N_FATS - n_dir) / au;
	if (   (fmt == FS_FAT16 && n_clst < MIN_FAT16)
		|| (fmt == FS_FAT32 && n_clst < MIN_FAT32))
		return FR_MKFS_ABORTED;

	/* ߰èݕ\żID */
	if (fmt == FS_FAT32) {
		sys = 0x0C;		/* FAT32X */
	} else {
		if (fmt == FS_FAT12 && n_vol < 0x10000) {
			sys = 0x01;	/* FAT12(<65536) */
		} else {
			sys = (n_vol < 0x10000) ? 0x04 : 0x06;	/* FAT16(<65536) : FAT12/16(>=65536) */
		}
	}

	if (_MULTI_PARTITION && part) {
		/* ߰èݕ\żIDXV */
		tbl = &fs->win[MBR_Table + (part - 1) * SZ_PTE];
		tbl[4] = sys;
		if (disk_write(pdrv, fs->win, 0, 1) != RES_OK)	/* MBRɏ */
			return FR_DISK_ERR;
		md = 0xF8;
	} else {
		if (sfd) {	/* ߰èݕ\Ȃ(SFD) */
			md = 0xF0;
		} else {	/* ߰èݕ\쐬(FDISK) */
			mem_set(fs->win, 0, SS(fs));
			tbl = fs->win + MBR_Table;	/* ײޓ̒P߰è݂߰èݕ\쐬 */
			tbl[1] = 1;						/* ߰è݊Jnͯ */
			tbl[2] = 1;						/* ߰è݊Jn */
			tbl[3] = 0;						/* ߰è݊Jn */
			tbl[4] = sys;					/* ь` */
			tbl[5] = 254;					/* ߰èݏIͯ */
			n = (b_vol + n_vol) / 63 / 255;
			tbl[6] = (BYTE)(n >> 2 | 63);	/* ߰èݏI */
			tbl[7] = (BYTE)n;				/* ߰èݏI */
			ST_DWORD(tbl + 8, 63);			/* LBAł߰è݊Jn */
			ST_DWORD(tbl + 12, n_vol);		/* LBAł߰èݗe */
			ST_WORD(fs->win + BS_55AA, 0xAA55);	/* MBR[ */
			if (disk_write(pdrv, fs->win, 0, 1) != RES_OK)	/* MBRɏ */
				return FR_DISK_ERR;
			md = 0xF8;
		}
	}

	/* VBRBPB쐬 */
	tbl = fs->win;							/*  */
	mem_set(tbl, 0, SS(fs));
	mem_cpy(tbl, "\xEB\xFE\x90" "MSDOS5.0", 11);/* ްĕ, OEM */
	i = SS(fs);								/* e */
	ST_WORD(tbl + BPB_BytsPerSec, i);
	tbl[BPB_SecPerClus] = (BYTE)au;			/* ׽̾ */
	ST_WORD(tbl + BPB_RsvdSecCnt, n_rsv);	/* \ */
	tbl[BPB_NumFATs] = N_FATS;				/* FAT */
	i = (fmt == FS_FAT32) ? 0 : N_ROOTDIR;	/* {ިڸؓ */
	ST_WORD(tbl + BPB_RootEntCnt, i);
	if (n_vol < 0x10000) {					/*  */
		ST_WORD(tbl + BPB_TotSec16, n_vol);
	} else {
		ST_DWORD(tbl + BPB_TotSec32, n_vol);
	}
	tbl[BPB_Media] = md;					/* }̋Lqq */
	ST_WORD(tbl + BPB_SecPerTrk, 63);		/* ׯ̾ */
	ST_WORD(tbl + BPB_NumHeads, 255);		/* ͯސ */
	ST_DWORD(tbl + BPB_HiddSec, b_vol);		/* B */
	n = GET_FATTIME();						/* VSNƂČݎgp */
	if (fmt == FS_FAT32) {
		ST_DWORD(tbl + BS_VolID32, n);		/* VSN */
		ST_DWORD(tbl + BPB_FATSz32, n_fat);	/* FAT̾ */
		ST_DWORD(tbl + BPB_RootClus, 2);	/* {ިڸ؊Jn׽(2) */
		ST_WORD(tbl + BPB_FSInfo, 1);		/* FSINFOںĕψ(VBR+1) */
		ST_WORD(tbl + BPB_BkBootSec, 6);	/* ް ںޕψ(VBR+6) */
		tbl[BS_DrvNum32] = 0x80;			/* ײޔԍ */
		tbl[BS_BootSig32] = 0x29;			/* gްĎ[ */
		mem_cpy(tbl + BS_VolLab32, "NO NAME    " "FAT32   ", 19);	/* ح فAFAT[ */
	} else {
		ST_DWORD(tbl + BS_VolID, n);		/* VSN */
		ST_WORD(tbl + BPB_FATSz16, n_fat);	/* FAT̾ */
		tbl[BS_DrvNum] = 0x80;				/* ײޔԍ */
		tbl[BS_BootSig] = 0x29;				/* gްĎ[ */
		mem_cpy(tbl + BS_VolLab, "NO NAME    " "FAT     ", 19);	/* ح فAFAT[ */
	}
	ST_WORD(tbl + BS_55AA, 0xAA55);			/* [(ψʂ;eʂɍS炸Ō߂) */
	if (disk_write(pdrv, tbl, b_vol, 1) != RES_OK)	/* VBR֏ */
		return FR_DISK_ERR;
	if (fmt == FS_FAT32)					/* KvȂAVBR(VBR+6)ɏ */
		disk_write(pdrv, tbl, b_vol + 6, 1);

	/* FAT̈揉 */
	wsect = b_fat;
	for (i = 0; i < N_FATS; i++) {		/* eFAT */
		mem_set(tbl, 0, SS(fs));			/* FAT̐擪 */
		n = md;								/* }̋Lqq޲ */
		if (fmt != FS_FAT32) {
			n |= (fmt == FS_FAT12) ? 0x00FFFF00 : 0xFFFFFF00;
			ST_DWORD(tbl + 0, n);			/* \׽ԍ0,1(FAT12/16) */
		} else {
			n |= 0xFFFFFF00;
			ST_DWORD(tbl + 0, n);			/* \׽ԍ0,1(FAT32) */
			ST_DWORD(tbl + 4, 0xFFFFFFFF);
			ST_DWORD(tbl + 8, 0x0FFFFFFF);	/* {ިڸؗp\׽ԍ2 */
		}
		if (disk_write(pdrv, tbl, wsect++, 1) != RES_OK)
			return FR_DISK_ERR;
		mem_set(tbl, 0, SS(fs));			/* 㑱FAT0Ŗ */
		for (n = 1; n < n_fat; n++) {		/* ̌JԂ͑̒P꾸݂̂߂FAT32حтɉĎԂ邩܂B */
			if (disk_write(pdrv, tbl, wsect++, 1) != RES_OK)
				return FR_DISK_ERR;
		}
	}

	/* {ިڸ؏ */
	i = (fmt == FS_FAT32) ? au : (UINT)n_dir;
	do {
		if (disk_write(pdrv, tbl, wsect++, 1) != RES_OK)
			return FR_DISK_ERR;
	} while (--i);

#if _USE_TRIM	/* KvȂAް̈ */
	{
		eb[0] = wsect; eb[1] = wsect + (n_clst - ((fmt == FS_FAT32) ? 1 : 0)) * au - 1;
		disk_ioctl(pdrv, CTRL_TRIM, eb);
	}
#endif

	/* KvȂAFSINFO쐬 */
	if (fmt == FS_FAT32) {
		ST_DWORD(tbl + FSI_LeadSig, 0x41615252);
		ST_DWORD(tbl + FSI_StrucSig, 0x61417272);
		ST_DWORD(tbl + FSI_Free_Count, n_clst - 1);	/* 󂫸׽ */
		ST_DWORD(tbl + FSI_Nxt_Free, 2);			/* 蓖ĂꂽŏI׽ԍ */
		ST_WORD(tbl + BS_55AA, 0xAA55);
		disk_write(pdrv, tbl, b_vol + 1, 1);	/* {(VBR+1) */
		disk_write(pdrv, tbl, b_vol + 7, 1);	/* ֏(VBR+7) */
	}

	return (disk_ioctl(pdrv, CTRL_SYNC, 0) == RES_OK) ? FR_OK : FR_DISK_ERR;
}

#if _MULTI_PARTITION
/*-----------------------------------------------------------------------*/
/* ײނ߰èݕ\쐬                                            */
/*-----------------------------------------------------------------------*/

FRESULT f_fdisk (
	BYTE pdrv,			/* ײޔԍ */
	const DWORD szt[],	/* e߰è݂ɑ΂eʕ\ւ̈ʒuwq */
	void* work			/* ƊɏՕւ̈ʒuwq */
)
{
	UINT i, n, sz_cyl, tot_cyl, b_cyl, e_cyl, p_cyl;
	BYTE s_hd, e_hd, *p, *buf = (BYTE*)work;
	DSTATUS stat;
	DWORD sz_disk, sz_part, s_part;

	stat = disk_initialize(pdrv);
	if (stat & STA_NOINIT) return FR_NOT_READY;
	if (stat & STA_PROTECT) return FR_WRITE_PROTECTED;
	if (disk_ioctl(pdrv, GET_SECTOR_COUNT, &sz_disk)) return FR_DISK_ERR;

	/* ײޔzuɍS炸\CHS */
	for (n = 16; n < 256 && sz_disk / n / 63 > 1024; n *= 2) ;
	if (n == 256) n--;
	e_hd = n - 1;
	sz_cyl = 63 * n;
	tot_cyl = sz_disk / sz_cyl;

	/* ߰èݕ\쐬 */
	mem_set(buf, 0, _MAX_SS);
	p = buf + MBR_Table; b_cyl = 0;
	for (i = 0; i < 4; i++, p += SZ_PTE) {
		p_cyl = (szt[i] <= 100U) ? (DWORD)tot_cyl * szt[i] / 100 : szt[i] / sz_cyl;
		if (!p_cyl) continue;
		s_part = (DWORD)sz_cyl * b_cyl;
		sz_part = (DWORD)sz_cyl * p_cyl;
		if (i == 0) {	/* 0̐擪ׯO */
			s_hd = 1;
			s_part += 63; sz_part -= 63;
		} else {
			s_hd = 0;
		}
		e_cyl = b_cyl + p_cyl - 1;
		if (e_cyl >= tot_cyl) return FR_INVALID_PARAMETER;

		/* ߰èݕ\ݒ */
		p[1] = s_hd;						/* Jnͯ */
		p[2] = (BYTE)((b_cyl >> 2) + 1);	/* Jn */
		p[3] = (BYTE)b_cyl;					/* Jn */
		p[4] = 0x06;						/* ь`(ꎞݒ) */
		p[5] = e_hd;						/* Iͯ */
		p[6] = (BYTE)((e_cyl >> 2) + 63);	/* I */
		p[7] = (BYTE)e_cyl;					/* I */
		ST_DWORD(p + 8, s_part);			/* LBAł̊Jn */
		ST_DWORD(p + 12, sz_part);			/* ߰èݗe */

		/* ߰è */
		b_cyl += p_cyl;
	}
	ST_WORD(p, 0xAA55);

	/* MBRɏ */
	return (disk_write(pdrv, buf, 0, 1) != RES_OK || disk_ioctl(pdrv, CTRL_SYNC, 0) != RES_OK) ? FR_DISK_ERR : FR_OK;
}

#endif /* _MULTI_PARTITION */
#endif /* _USE_MKFS && !_FS_READONLY */

#if _USE_STRFUNC
/*-----------------------------------------------------------------------*/
/* ̧ق當擾                                                  */
/*-----------------------------------------------------------------------*/

TCHAR* f_gets (
	TCHAR* buff,	/* ǂނ߂̕ɏՕւ̈ʒuwq */
	int len,		/* ɏՕ̑傫() */
	FIL* fp			/* ّ̧Ώەւ̈ʒuwq */
)
{
	int n = 0;
	TCHAR c, *p = buff;
	BYTE s[2];
	UINT rc;

	while (n < len - 1) {	/* ɏՕ܂ŕǂݍ */
#if _USE_LFN && _LFN_UNICODE
#if _STRF_ENCODE == 3		/* UTF-8ŕǂݍ */
		f_read(fp, s, 1, &rc);
		if (rc != 1) break;
		c = s[0];
		if (c >= 0x80) {
			if (c < 0xC0) continue;	/* VI[΂ */
			if (c < 0xE0) {			/* 2޲č\ */
				f_read(fp, s, 1, &rc);
				if (rc != 1) break;
				c = (c & 0x1F) << 6 | (s[0] & 0x3F);
				if (c < 0x80) c = '?';
			} else {
				if (c < 0xF0) {		/* 3޲č\ */
					f_read(fp, s, 2, &rc);
					if (rc != 2) break;
					c = c << 12 | (s[0] & 0x3F) << 6 | (s[1] & 0x3F);
					if (c < 0x800) c = '?';
				} else {			/* 4޲č\ */
					c = '?';
				}
			}
		}
#elif _STRF_ENCODE == 2		/* UTF-16BEŕǂݍ */
		f_read(fp, s, 2, &rc);
		if (rc != 2) break;
		c = s[1] + (s[0] << 8);
#elif _STRF_ENCODE == 1		/* UTF-16LEŕǂݍ */
		f_read(fp, s, 2, &rc);
		if (rc != 2) break;
		c = s[0] + (s[1] << 8);
#else						/* ANSI/OEMŕǂݍ */
		f_read(fp, s, 1, &rc);
		if (rc != 1) break;
		c = s[0];
		if (IsDBCS1(c)) {
			f_read(fp, s, 1, &rc);
			if (rc != 1) break;
			c = (c << 8) + s[0];
		}
		c = ff_convert(c, 1);	/* OEMUnicode */
		if (!c) c = '?';
#endif
#else						/* ϊȂŕǂݍ */
		f_read(fp, s, 1, &rc);
		if (rc != 1) break;
		c = s[0];
#endif
		if (_USE_STRFUNC == 2 && c == '\r') continue;	/* '\r'΂ */
		*p++ = c;
		n++;
		if (c == '\n') break;		/* EOLŒf */
	}
	*p = 0;
	return n ? buff : 0;			/* ǂݍްȂ(EOL܂ُ͈)ɈُԂ */
}

#if !_FS_READONLY
#include <stdarg.h>
/*-----------------------------------------------------------------------*/
/* ̧قɕzu                                                      */
/*-----------------------------------------------------------------------*/

typedef struct {
	FIL* fp;
	int idx, nchr;
	BYTE buf[64];
} putbuff;


static
void putc_bfd (
	putbuff* pb,
	TCHAR c
)
{
	UINT bw;
	int i;

	if (_USE_STRFUNC == 2 && c == '\n')	 /* LF -> CRLF conversion */
		putc_bfd(pb, '\r');

	i = pb->idx;	/* ɏՕݎwW(-1:ُ) */
	if (i < 0) return;

#if _USE_LFN && _LFN_UNICODE
#if _STRF_ENCODE == 3			/* UTF-8ŕ */
	if (c < 0x80) {				/* 7ޯ */
		pb->buf[i++] = (BYTE)c;
	} else {
		if (c < 0x800) {		/* 11ޯ */
			pb->buf[i++] = (BYTE)(0xC0 | c >> 6);
		} else {				/* 16ޯ */
			pb->buf[i++] = (BYTE)(0xE0 | c >> 12);
			pb->buf[i++] = (BYTE)(0x80 | (c >> 6 & 0x3F));
		}
		pb->buf[i++] = (BYTE)(0x80 | (c & 0x3F));
	}
#elif _STRF_ENCODE == 2			/* UTF-16BEŕ */
	pb->buf[i++] = (BYTE)(c >> 8);
	pb->buf[i++] = (BYTE)c;
#elif _STRF_ENCODE == 1			/* UTF-16LEŕ */
	pb->buf[i++] = (BYTE)c;
	pb->buf[i++] = (BYTE)(c >> 8);
#else							/* ANSI/OEMŕ */
	c = ff_convert(c, 0);	/* UnicodeOEM */
	if (!c) c = '?';
	if (c >= 0x100)
		pb->buf[i++] = (BYTE)(c >> 8);
	pb->buf[i++] = (BYTE)c;
#endif
#else							/* ϊȂŕ */
	pb->buf[i++] = (BYTE)c;
#endif

	if (i >= (int)(sizeof pb->buf) - 3) {	/* ̧قɊɏՂꂽ */
		f_write(pb->fp, pb->buf, (UINT)i, &bw);
		i = (bw == (UINT)i) ? 0 : -1;
	}
	pb->idx = i;
	pb->nchr++;
}

int f_putc (
	TCHAR c,	/* oׂ͂ */
	FIL* fp		/* ّ̧Ώەւ̈ʒuwq */
)
{
	putbuff pb;
	UINT nw;

	pb.fp = fp;			/* o͊ɏՕ */
	pb.nchr = pb.idx = 0;

	putc_bfd(&pb, c);	/* zu */

	if (   pb.idx >= 0	/* ̧قɊɏՂꂽo */
		&& f_write(pb.fp, pb.buf, (UINT)pb.idx, &nw) == FR_OK
		&& (UINT)pb.idx == nw) return pb.nchr;
	return EOF;
}

/*-----------------------------------------------------------------------*/
/* ̧ق̕zu                                                    */
/*-----------------------------------------------------------------------*/

int f_puts (
	const TCHAR* str,	/* o͂镶ւ̈ʒuwq */
	FIL* fp				/* ّ̧Ώەւ̈ʒuwq */
)
{
	putbuff pb;
	UINT nw;

	pb.fp = fp;				/* o͊ɏՕ */
	pb.nchr = pb.idx = 0;

	while (*str)			/* zu */
		putc_bfd(&pb, *str++);

	if (   pb.idx >= 0		/* ̧قɊɏՂꂽo */
		&& f_write(pb.fp, pb.buf, (UINT)pb.idx, &nw) == FR_OK
		&& (UINT)pb.idx == nw) return pb.nchr;
	return EOF;
}

/*-----------------------------------------------------------------------*/
/* ̧قɌ`ꂽzu                                        */
/*-----------------------------------------------------------------------*/

int f_printf (
	FIL* fp,			/* ّ̧Ώەւ̈ʒuwq */
	const TCHAR* fmt,	/* `ւ̈ʒuwq */
	...					/* CӑI */
)
{
	va_list arp;
	BYTE f, r;
	UINT nw, i, j, w;
	DWORD v;
	TCHAR c, d, s[16], *p;
	putbuff pb;

	pb.fp = fp;				/* o͊ɏՕ */
	pb.nchr = pb.idx = 0;

	va_start(arp, fmt);

	for (;;) {
		c = *fmt++;
		if (c == 0) break;			/* ̍Ō */
		if (c != '%') {				/* ߕȂ */
			putc_bfd(&pb, c);
			continue;
		}
		w = f = 0;
		c = *fmt++;
		if (c == '0') {				/* ׸:'0'[U */
			f = 1; c = *fmt++;
		} else {
			if (c == '-') {			/* ׸:l */
				f = 2; c = *fmt++;
			}
		}
		while (IsDigit(c)) {		/* x */
			w = w * 10 + c - '0';
			c = *fmt++;
		}
		if (c == 'l' || c == 'L') {	/* ړ:傫long int */
			f |= 4; c = *fmt++;
		}
		if (!c) break;
		d = c;
		if (IsLower(d)) d -= 0x20;
		switch (d) {				/* `? */
		case 'S' :					/*  */
			p = va_arg(arp, TCHAR*);
			for (j = 0; p[j]; j++) ;
			if (!(f & 2)) {
				while (j++ < w) putc_bfd(&pb, ' ');
			}
			while (*p) putc_bfd(&pb, *p++);
			while (j++ < w) putc_bfd(&pb, ' ');
			continue;
		case 'C' :					/*  */
			putc_bfd(&pb, (TCHAR)va_arg(arp, int)); continue;
		case 'B' :					/* 2il */
			r = 2; break;
		case 'O' :					/* 8il */
			r = 8; break;
		case 'D' :					/* t10il */
		case 'U' :					/* Ȃ10il */
			r = 10; break;
		case 'X' :					/* 16il */
			r = 16; break;
		default:					/* ̌`(̂܂ܒʉ) */
			putc_bfd(&pb, c); continue;
		}

		/* 擾ĐŔzu */
		v = (f & 4) ? (DWORD)va_arg(arp, long) : ((d == 'D') ? (DWORD)(long)va_arg(arp, int) : (DWORD)va_arg(arp, unsigned int));
		if (d == 'D' && (v & 0x80000000)) {
			v = 0 - v;
			f |= 8;
		}
		i = 0;
		do {
			d = (TCHAR)(v % r); v /= r;
			if (d > 9) d += (c == 'x') ? 0x27 : 0x07;
			s[i++] = d + '0';
		} while (v && i < sizeof s / sizeof s[0]);
		if (f & 8) s[i++] = '-';
		j = i; d = (f & 1) ? '0' : ' ';
		while (!(f & 2) && j++ < w) putc_bfd(&pb, d);
		do putc_bfd(&pb, s[--i]); while (i);
		while (j++ < w) putc_bfd(&pb, d);
	}

	va_end(arp);

	if (   pb.idx >= 0		/* ̧قɊɏՂꂽo */
		&& f_write(pb.fp, pb.buf, (UINT)pb.idx, &nw) == FR_OK
		&& (UINT)pb.idx == nw) return pb.nchr;
	return EOF;
}

#endif /* !_FS_READONLY */
#endif /* _USE_STRFUNC */
